
( ." power version 102" cr )
( ." copyright 1992,1993 kevin stokes and colin stokes" cr )
( ." compiling pygmyini.4th"  cr )

( modified for 32-bit, multi-tasking Forth by Frank Sergeant)

( modified for 32-bit Windows and MSVC, May '98, Frank Sergeant)
( for first testing, turn off SAVEs near end of file           )
( change 200 to 1024 in (BOOT2    (but (BOOT2 probably not needed at all)
( ok -- it loads clean.  It probably won't run unless we can find       )
(    -- all the C routines it needs.  Let's dummy some out for now:     )
( Comment out activation of (BOOT2                                      )
( What was the point of DUMKEY, just to prevent any real keyboard access)
(   when running Forth unless I used >NORMKEY for debuggin ?            )
(   Anyway, it screws things up, so comment out redefines of BYE & #BYE )
( At this point, the following works and runs                           )
(    lfcon fthx1.img                                                    )
(    5 LOAD BYE                                                         )
(    lfcon fthx2.img                                                    )
(    INCLUDE newini2.fth                                                )
(    BYE                                                                )
(    lfcon fthm4.img                                                    )


CR ." Loading newini2.4th to create fthm4.img" CR

1 CONSTANT CDMEET ( code for if get close to player )
2 CONSTANT CDWOUND ( code for if gets shot by player )
3 CONSTANT CDKILL  ( code for if guard is killed )
4 CONSTANT CDHIT   ( code for if the guard scores a hit on the player )
5 CONSTANT CDWALK  ( code for if the guard are walking )
6 CONSTANT CDTURN  ( code for if the guard is changing direction )
7 CONSTANT CDSEE   ( code for if the guard sees player )
8 CONSTANT CDINIT  ( code to be run at beginning to initialize guard )
9 CONSTANT CDSTAND ( code to be run when guard is sentried )
10 CONSTANT CDALERT ( code to be run when guard gets alerted )

1000 CONSTANT MAX_MEET_DIST ( Must be this close to guard in order to run CDMEET behavior )
3000 CONSTANT MAX_WALK_SENSE ( Must be at least this close to guard in order to operate walking behavior )

300 CONSTANT MAX_DIST_TRACKDOWN  ( This is the distance where we stop trying to get closer if not attacking )
800 CONSTANT MIN_DIST_START_FOLLOWING   ( If we are curious and not attacking, this is the distance )
                                        ( where we get curious and start following the player again )

-1 CONSTANT TRUE
0  CONSTANT FALSE

32 CONSTANT MAXGUARDS


16 CONSTANT BITROBODEAD
512 CONSTANT BITMETAMORPH


4 CONSTANT CELL
: CELLS ( #cells - #bytes)  CELL  *  ;


COMMENT(

( load block)
CR  ." Before HERE = " HERE U.
( 229 233 THRU   ( TRACE-ON  TRACE-OFF)
2002 2149 THRU   ( will later go into PYGMYINI.4TH)
( 2150 2154 THRU ( includes some diagnostic routines)
2156 2167 THRU   ( tasks -- will later go into GUARD??.4TH )

CLOSE-FILES
SAVE FTHM4.IMG
SAVE \PMIN\FTHM4.IMG
CR  ." After  HERE = " HERE U.  CR

)COMMENT




( application specific user variables)
CAPS @  SAVE-CAPS !   CAPS OFF
( *** Must preserve the mixed case of following section ***)
( ***    All CODE words must be defined with CAPS OFF   ***)
: USER ( u - u')  ( - a)
  HEAD  b push  UP #) di X  b mov  ( u)
  DUP b add#  NXT, ( u)  4 +  ;
( We must start with an offset of 24, as there are)
( 6 previous user variables and each takes 4 bytes)
( These will eliminate the ROBO[] and CUROBOFF stuff)
( Later, we might consider using byte-sized items to save)
( space.)
( e.g.  24 USER XXX               )
(          USER YYY               )
(          USER ZZZ    ....  DROP )


( Shift)
CODE >>> ( u # - u') b c mov    b pop  c b shr   NXT, END-CODE
CODE S>>> ( u # - u') b c mov   b pop  c b sar   NXT, END-CODE
CODE <<< ( u # - u') b c mov    b pop  c b shl   NXT, END-CODE
( I've renamed above <<< & >>> so they will not conflict  )
(      with the assembler's << & >>                       )



CODE 256/ ( u - u/256)  8 b shr  NXT,  END-CODE
 ( Should 256/ be replaced with  8 >>> every place it is used?)
 ( Or, use _separate_ variables rather than trying to cram two)
 (   into a single variable.                                  )

VARIABLE ITMP

VARIABLE SHOT_A_FRIENDLY
0 SHOT_A_FRIENDLY !

1 CONSTANT RATSKATE
2 CONSTANT RATFLY
4 CONSTANT RATHOVER

4 CONSTANT MXTYPS
VARIABLE TYPATTR MXTYPS CELLS ALLOT
0 TYPATTR !
RATSKATE RATFLY + RATHOVER + TYPATTR 1 CELLS + !
RATSKATE RATFLY + TYPATTR 2 CELLS + !
RATSKATE TYPATTR 3 CELLS + !

16 CONSTANT #GUARD-TYPES
15 CONSTANT MAXGT ( Must be 1 minus power of 2 )

0 CONSTANT WALK.START
1 CONSTANT WALK.END
2 CONSTANT RUN.START
3 CONSTANT RUN.END
4 CONSTANT DEATH.START
5 CONSTANT DEATH.END
6 CONSTANT DEATH.SCORE
7 CONSTANT DEATH.FLAGS
8 CONSTANT KO.START
9 CONSTANT KO.END
10 CONSTANT KO.SCORE
11 CONSTANT KO.FLAGS
12 CONSTANT GOO.START
13 CONSTANT GOO.END
14 CONSTANT GOO.SCORE
15 CONSTANT GOO.FLAGS
16 CONSTANT COUGH.START
17 CONSTANT COUGH.END
18 CONSTANT COUGH.SCORE
19 CONSTANT COUGH.FLAGS
20 CONSTANT HIT.START
21 CONSTANT HIT.END
22 CONSTANT WIDTH.WIDTH
23 CONSTANT MOVE.TYPE
24 CONSTANT SHOOT.START
25 CONSTANT SHOOT.END
26 CONSTANT SHOOT.LOOP
27 CONSTANT SHOOT.BANG
28 CONSTANT SHOOT.FLAGS
29 CONSTANT HEY.START
30 CONSTANT HEY.END
31 CONSTANT DIESND.START
32 CONSTANT DIESND.END
33 CONSTANT HITSND.SND
34 CONSTANT WALKSND.START
35 CONSTANT WALKSND.END
36 CONSTANT SHOOTSND.SND
37 CONSTANT SHOOTSND.RANGE
38 CONSTANT GOOED.SND
39 CONSTANT KOED.SND
40 CONSTANT TEAR.SND
41 CONSTANT SOUND.FLAGS
42 CONSTANT MOVE.STRIDE
43 CONSTANT MOVE.RANGE
44 CONSTANT SHOOT.LIGHT
45 CONSTANT SHOOT.NSHOT
46 CONSTANT DOOROPEN.RANGE
47 CONSTANT WALK.DELAY
48 CONSTANT RUN.DELAY
49 CONSTANT TURN.DELAY
50 CONSTANT FASTTURN.DELAY
51 CONSTANT SHOOT.DELAY
52 CONSTANT DEATH.DELAY
53 CONSTANT STAND.START
54 CONSTANT STAND.END
55 CONSTANT STAND.DELAY
57 CONSTANT TURN.START
58 CONSTANT TURN.END
59 CONSTANT #GA

1 CONSTANT SHOOTFLAG_NOREVHOLSTER  ( Do not run through shooting frames in reverse to holster )

( Make an array of attribute data for up to 16 types of enemies.  Fill with default )
( values for all of them. )
VARIABLE GA-DATA  #GA #GUARD-TYPES * ALLOT


( [Value] [ GA_OFFSET ] [GA_TYPE#] -- [] )
: GA_STORE
  #GA * GA-DATA + + C! 
;

: GA_DEFAULTS
  #GUARD-TYPES FOR 
    0 WALK.START I GA_STORE
    8 WALK.END   I GA_STORE
    24 RUN.START I GA_STORE
    27 RUN.END   I GA_STORE
    9 DEATH.START I GA_STORE
    12 DEATH.END  I GA_STORE
    0 DEATH.FLAGS I GA_STORE
    10 DEATH.SCORE I GA_STORE
    29 KO.START    I GA_STORE
    32 KO.END      I GA_STORE
    10  KO.SCORE    I GA_STORE 
    9  KO.FLAGS    I GA_STORE 
    13 GOO.START   I GA_STORE
    15 GOO.END     I GA_STORE
    5  GOO.SCORE   I GA_STORE
    0  GOO.FLAGS   I GA_STORE
    16 COUGH.START I GA_STORE
    17 COUGH.END   I GA_STORE
    1 COUGH.SCORE   I GA_STORE
    5 COUGH.FLAGS   I GA_STORE
    23 HIT.START   I GA_STORE
    23 HIT.END     I GA_STORE
    15 WIDTH.WIDTH I GA_STORE
    3   MOVE.TYPE  I GA_STORE
    18 SHOOT.START I GA_STORE
    22 SHOOT.END   I GA_STORE
    21 SHOOT.LOOP  I GA_STORE
    22 SHOOT.BANG  I GA_STORE
    0  SHOOT.FLAGS I GA_STORE
    20 HEY.START   I GA_STORE
    23 HEY.END     I GA_STORE
    24 DIESND.START I GA_STORE
    27 DIESND.END  I GA_STORE
    0  HITSND.SND  I GA_STORE
    0 WALKSND.START I GA_STORE
    0 WALKSND.END  I GA_STORE
    1 SHOOTSND.SND I GA_STORE
    50 SHOOTSND.RANGE I GA_STORE
    24 GOOED.SND I GA_STORE
    25 KOED.SND I GA_STORE
    26 TEAR.SND I GA_STORE
    0 SOUND.FLAGS  I GA_STORE
   25 MOVE.STRIDE I GA_STORE  ( Mult by 20 to get actual stride.  41= stride of 820 )
    0 MOVE.RANGE I GA_STORE
    16 SHOOT.LIGHT I GA_STORE ( Lighting effect for cl0tmp3 when shooting )
    5  SHOOT.NSHOT I GA_STORE ( Number of potshots to take in roboshoot )
    80 DOOROPEN.RANGE I GA_STORE ( How close you must be to open a door div by 10. 0=never )
    10 WALK.DELAY I GA_STORE
    10 RUN.DELAY I GA_STORE
    10 TURN.DELAY I GA_STORE
    10 FASTTURN.DELAY I GA_STORE
    10 SHOOT.DELAY I GA_STORE
    10 DEATH.DELAY I GA_STORE

    0 STAND.START I GA_STORE
    0 STAND.END I GA_STORE
   10 STAND.DELAY I GA_STORE
    0 TURN.START I GA_STORE
    0 TURN.END I GA_STORE
  NEXT
;

GA_DEFAULTS





COMMENT(
 ( Here is another possible pseudo random number generator.)
 ( Save it here for future reference.                      )

 VARIABLE seed     457454 seed !
 : random ( - u)  seed @  69069 * 1+ DUP seed !  ;
 : upto   ( range - u)  random UM* NIP  ;

)COMMENT







( Pseudo Random Number Generator )
VARIABLE rng1      VARIABLE rng2      VARIABLE rng3

 457454 rng1 !     937254 rng2 !      457454 1234982 - rng3 !

COMMENT(  this is the version that seems to fail to account for
          the indirection via register EDI
CODE RANDN ( - u)
 b push rng1 #) a mov  rng2 #) b mov rng3 #) c mov
 b a xor  cl a ror  c b adc  a c xor  c rng3 #) mov
 b rng2 #) mov  a rng1 #) mov  a b mov  NXT,  END-CODE
)COMMENT

( Here is the attempt to fix it )
CODE RANDN ( - u)
 b push rng1 #) di X a mov  rng2 #) di X b mov rng3 #) di X c mov
 b a xor  cl a ror  c b adc  a c xor  c rng3 #) di X mov
 b rng2 #) di X mov  a rng1 #) di X mov  a b mov  NXT,  END-CODE

: RANDR ( rang - u)  RANDN  UM*  NIP  ;

COMMENT(   ( above is PRNG we are currently using )
 : TEST ( -) FOR 100 RANDR .  NEXT  ;
)COMMENT


CODE FRAC*  ( n1 n2 - n1*n2/65536)
 ( do a signed multiply of top two stack items, then     )
 ( descale by 2^16. Alternatively, should we use */  ?   )
   a pop   b imul   a b mov   16 b sar
 NXT, END-CODE

CODE SX  ( 16-bit - 32-bit)
  ( sign extend 16-bits to 32-bits)
  16 b shl   16 b sar  NXT,  END-CODE

CODE SIGN-EXTEND-BYTE ( c - n)
  ( sign extend 8-bits to 32-bits)
  24 b shl  24 b sar   NXT,  END-CODE





CODE -ROT  ( a b c - c a b)
   b a mov   b pop   c pop   a push   c push
 NXT, END-CODE



: RPUSH, ( reg -) CELL bp sub#  0 bp )  ( reg) mov  ;
: RPOP,  ( reg -)  PUSH 0 bp ) POP mov  CELL bp add#  ;






 COMMENT(
WATCOM: and CDECL: define words which call external functions.
We set things up so the Forth stack comment order looks the same
as the C function prototype.  CDECL: is for functions which
expect arguments on the stack with the left-most argument in the
prototype on top of the stack.  WATCOM: is for functions which
use the Watcom register calling convention.  In this case the
arguments in the prototype go into registers in this order:
leftmost into eax, next into edx, next into ebx, rightmost into
ecx.  Watcom expects more than 4 arguments to overflow onto the
stack, but we will not do that.  We limit the number of argments
to a maximum of 4 (for the Watcom register calling convention).
Thus a C function with prototype (int a, int b, intc) would have
a Forth stack comment of ( a b c -).  In both cases, we _switch_
to the C stack for safety before calling the external routine.
 )COMMENT


COMMENT(   *** May98 none of the C/Windows routines Forth
           *** will call use the WATCOM calling convention,
           *** but save this in case of a future compiler
           *** change.
( Interface to a Watcom register calling convention routine)
: WATCOM:  ( #in #out 'address -)   CODE
  PUSH SWAP ( #out #in)
  b push   bp a mov       ( save our return stack pointer)
  2 di ) bp mov  ( bp now points to C's stack to be)
  DUP FOR   b pop  b RPUSH,  NEXT  ( move parms off data stack)
  a push  di push  si push  ( save rstk prt and others)
  bp sp xchg ( save our data stack in bp and point sp to C stk)
  DUP IF 1- a pop THEN  DUP IF 1- d pop THEN
  DUP IF 1- b pop THEN  IF  c pop  THEN ( load args into regs)
  POP #) di X call  ( actually call the C routine)
  sp bp xchg     ( give us back our real data stack pointer)
  si pop  di pop  bp pop  ( & original return stack pointer etc)
  DUP 0= IF DROP  b pop ( refill TOS)  NXT,  EXIT THEN
  2 = IF d push THEN a b mov ( result to TOS) NXT,   ;
)COMMENT


( Interface to a cdecl C routine)
: CDECL:  ( #in #out 'address -)   CODE
  PUSH SWAP ( #out #in)
  b push         ( TOS to real stack)
  bp a mov       ( save our return stack pointer)
  2 di ) bp mov  ( bp now points to C's stack to be)
  FOR   b pop  b RPUSH,  NEXT  ( move parms to C's stack to be)
  a push         ( save our original return stack pointer)
  di push  si push  ( and save ORIGIN register and IP as well)
  bp sp xchg     ( save our data stack in bp and make sp point
                   to C's stack)
  POP #) di X call  ( actually call the C routine)
  sp bp xchg     ( give us back our real data stack pointer)
  si pop  di pop  bp pop  ( & original return stack pointer etc)
  DUP 0= IF DROP  b pop ( refill TOS)  NXT,  EXIT THEN
  2 = IF d push THEN a b mov ( result to TOS) NXT,   ;

COMMENT(
  A B C P*/ is A * B/C but with a 64-bit intermediate product.
  X Y & D are signed.  X*Y = CB cannot overflow 64-bits, but
  [CB]/D overflows if |C| >= |D|.  In case of overflow, return
  a large number with the correct sign.  Don't allow overflow
  interrupt.
)COMMENT
CODE P*/  ( protected version of */ )
  a pop   c pop   c imul     d c mov
  c c or  0<, if   c neg   then  ( ie ecx is |C|)
  di push ( must save di, as it holds ORIGIN in CYGMY)
  b di mov   di di or   0<, if di neg  then ( ie edi is |D|)
  di c cmp  di pop  0<, if ( all ok) b idiv a b mov  NXT, then
  b b xor b dec 1 b shr  d a xor 0<, if b inc then
  NXT,   END-CODE


( ** I guess the following were to prevent Forth from actually   )
( **   accessing the keyboard unless >NORMKEY was done for       )
( **   debugging purposes.  Anyway, for now, comment out the     )
( **   redefinition of BYE & #BYE.  If we must do >DUMKEY  ???   )
: DUMKEY ( - c) $45 ;
: >DUMKEY ( -)   ['] DUMKEY IS KEY   ['] 0 IS KEY?   ;
: >NORMKEY ( -) ['] (KEY IS KEY   ['] (KEY? IS KEY?  ;

( : BYE >DUMKEY  BYE  ;      : #BYE  >DUMKEY  #BYE ; )


CODE ROTATER ( u # - u')
     b c mov  b pop  opsiz c b ror NXT, END-CODE
CODE ROTATEL ( w # - w')
     b c mov  b pop  opsiz c b rol NXT, END-CODE
( Note, above does a 16-bit rotation without disturbing   )
(   upper 16 bits.  Is this what we want now?             )
CODE 8ROTATEL ( c # - c')
     b c mov  b pop  c bl rol NXT, END-CODE

CODE 2+ ( n - n+2)  b inc b inc  NXT, END-CODE
CODE 2- ( n - n-2)  b dec b dec  NXT, END-CODE


( Will cause for-next loop to terminate on next next  )
( May be needed, but it often appears in fairly "long")
( words.  So, maybe its need will disappear when they )
( are rewritten.  If not, perhaps I should use the    )
( idiomatic u FOR .. flag IF NEXT  ELSE  POP DROP THEN)

CODE FORLEAVE    a a sub   a  0 bp ) mov   NXT, END-CODE










CODE COORDOK?  ( coord - tf)   ( sb high-level?)
 ( returns true if coord legal )
  b a mov 10000 a add#  0<, if  b b xor  NXT,  then
 10000 b cmp#  0<, not  if  b b xor  NXT,  then
  -1 b mov#   NXT,
 END-CODE
COMMENT(
  I think the above is saying the same as the high-level
  [ coord ]  -4999 4999 BETWEEN [ flag ]
  now [ coord ]  -9999 9999 BETWEEN [ flag ]
)COMMENT

: XYOK? ( x y - tf)      ( returns true if pair legal)
  COORDOK? SWAP COORDOK? AND  ;




16 CONSTANT NPOIS
 6 CONSTANT NBYTEPOIS
VARIABLE POIS   NPOIS NBYTEPOIS * ALLOT
POIS NPOIS NBYTEPOIS * 0 FILL          ( clear data to zero )
VARIABLE CURPOIS    ( only used in PP, but PP not used here )
POIS CURPOIS !  ( start it out pointing at pose )

0 CONSTANT POISX
2 CONSTANT POISY
4 CONSTANT POIST       ( assume still 2 bytes per field )






COMMENT(

CODE PP ( parm# - parm-value )
  ( should this be  : PP [ parm# - value] CURPOIS @ + W@ ;)
  ( value found using curpois )
  ( CURPOIS )   ( BX ADD,  0 [BX] BX MOV,)
  CURPOIS #) di X b add     0 b ) b movsx
NXT, END-CODE


( Note, above seem to be 16-bit fields, but the parm# seems to
  be a byte offset.  However, PP doesn't seem to be used in
  this file.)
)COMMENT



( ADVANCEPOISON  reduces time values for active poisons)
CODE ADVANCEPOISON  ( -)
 b push   POIS b mov#  di b add   NPOIS c mov#
 begin  POIST b ) a movsx   a a or
        0=, not if  opsiz POIST b ) dec  then
        ( if poison is active, then time it down a little )
        NBYTEPOIS b add#   c dec
 0=, until
 b pop   NXT,   END-CODE

COMMENT( in high-level, above might be
: REDUCEPOISON ( -)  ( decrement the POIST values)
  POIS POIST + ( a)
  NPOIS FOR ( a) DUP W@ 1- 0 MAX OVER W!  NBYTEPOIS + NEXT
  DROP  ;
 )COMMENT

( finds first free position for new poison )
CODE FIND1STPOIS ( - poisaddr)
  b push           ( save thing on stack )
  POIS b mov#  di b add    ( get start of array into bx )
  b d mov          ( store in dx register also )
  NPOIS c mov#      ( get max count )
  begin
   POIST b ) a movsx      a a or
   0=, if  1 c mov#      ( terminate loop )
           b d mov       ( put address in dx )
   then
   NBYTEPOIS b add#       c dec
  0=, until   ( if count exhausts, return addr of first entry)
  d b mov  di b sub   ( put address on tos )
  NXT,  END-CODE


VARIABLE TEMPX   ( used by POISONCHECK )
VARIABLE TEMPY   (        ditto        )




VARIABLE DEBUG1   ( general debug counters )
VARIABLE DEBUG2
VARIABLE DEBUG3








( POISONCHECK  returns address if poisoned, 0 if none found )
CODE POISONCHECK  ( x y - address|0)
  b  TEMPY #) di X mov   ( save x and y in variables )
  b pop   b  TEMPX #) di X mov
  si push  ( we must save IP)
  POIS b mov#  di b add    ( get start of array into bx )
  0 si mov#       ( assume return value will be zero)
  NPOIS c mov#      ( get max count )
  begin
   POIST b )  a movsx     a a or
   0=, not  if
     TEMPY #) di X a mov    opsiz POISY b )  a sub
     0<, if   ( take abs value ) opsiz a neg  then
     TEMPX #) di X d mov    opsiz POISX b ) d sub
     0<, if   ( take abs value ) opsiz d neg  then
     opsiz a d cmp

( POISONCHECK  continued)
        0<, not  if   ( see which is bigger, and take bigger)
            d a mov
        then
        opsiz 16bit 900 a cmp#  32bit
        0<, if
          1 c mov#      ( terminate loop )   di b sub
          b si mov      ( put address in si )
        then
     then
     NBYTEPOIS b add#   c dec
  0=, until    si b mov  ( return address|0)
  si pop   ( restore IP)   NXT,   END-CODE
( POISONCHECK return address of first poisoned area whose max )
( axial distance is less than 900 units from point x,y,       )
( otherwise return zero, right?                               )

COMMENT(
: POISONCHECK ( x y - a|0)
  POIS POIST + DUP NPOIS NBYTEPOIS * + PUSH  ( x y a || last)
  BEGIN ( x y a)  DUP W@
    IF ( we found an active poison)
       PUSH 2DUP   R@ 2 - SW@ ( ie y) - ABS
              SWAP R@ 4 - SW@ ( ie x) - ABS MAX 900 <
               IF ( x y || a last)
                  2DROP POP POP DROP 4 -   EXIT
               THEN
       POP ( x y a || last)
    THEN
    NBYTEPOIS + DUP R@ >
  UNTIL
  ( we reached the end of the line) ( x y a' || last)
  POP 2DROP 2DROP  0   ;                             )COMMENT

( makes an entry )
( Each entry is still 16 bits)
CODE (POISONENTRY  ( x y t poisaddr - )
   di b add  ( adjust to absolute address)
   a pop   opsiz a  POIST b ) mov
   a pop   opsiz a  POISY b ) mov
   a pop   opsiz a  POISX b ) mov
   b pop  ( refill TOS)
 NXT,  END-CODE

COMMENT( above should be high-level?, e.g.
  : POISON! ( x y t addr -)
    PUSH  R@ W!   R@ 2+ W!  POP 4 + W!   ;
 )COMMENT



( makes a poison entry in pois data )
: POISONENTRY  ( x y t - )
   FIND1STPOIS (POISONENTRY  ;














COMMENT(  Note, the need for CVAR, CVAR@, CVAR!, & CVAR+!
   goes away merely by using a CREATE DOES> word for
   each desired C variable which leaves the address of
   the C variable (converted to a relative CYGMY address)
   on the stack.  Then ordinary  C@ C! W@ W! @ ! +! etc
   will work fine.  Warning **** it is important to keep
   straight whether a particular address is relative to
   CYGMY's origin or whether it is an absolute address.
   Further, these will need careful review if we change
   to an "absolute" Forth, where, for speed, we do not
   use relative addresses at all.

   Make C variables directly addressable.  An initialization
   call from C must be made to pass the correct address and
   store it in 'CVARIABLES
)COMMENT

VARIABLE 'CVARIABLES
         ( holds relative address of array of              )
         ( "intptrs" in the calling C module               )
         ( use something like   &intptrs REL 'CVARIABLES ! )

CODE REL   ( a - a-origin)  di b sub  NXT,  END-CODE

CODE UNREL ( a-origin - a)  di b add  NXT,  END-CODE
  ( we wish to call it 'ABS' but that word is already in use)



SAVE-CAPS @  CAPS !
( *** End of section where mixed case must be preserved *** )



COMMENT(
  Note about Watcom/DOS4GW:  I _think_ the way DOS4GW sets
  up segment descriptors etc that our C program will always
  be loaded at the _same_ linear address.  If we can establish
  this, we might eliminate some of the indirection used here
  to reference C variables.
)COMMENT

: CVAR:  ( # -)  ( - relative-address)
  CREATE  4 * ,  ( convert index number to a byte offset)
  DOES>  @  'CVARIABLES @  +  @  ( abs-addr)  REL  ;






( The following must be co-ordinated with the intptrs array   )
( defined in pygmy.c.  Some of these could use better names.  )

 0 CVAR: PYGMYCOMMAND
 1 CVAR: ROBONUM
 2 CVAR: OBJMEM+1         ( segment -- not needed)
 3 CVAR: OBJMEM           ( offset -- not needed)
 4 CVAR: PYGMYARG1
 5 CVAR: AVGTIME
 6 CVAR: AATAN2            ( function)
 7 CVAR: WX
 8 CVAR: WY
 9 CVAR: NHITS
10 CVAR: PATH_IS_CLEAR     ( function)
11 CVAR: 'INV_UTIL          ( function)


12 CVAR: ACTIONHALT
( 13 CVAR: XYHEX             ( function)
14 CVAR: GTYPENUM         ( integer variable for dealing with > 1 guard type per level ) 
15 CVAR: TICKPTR
16 CVAR: PF1          ( "profile" - used in ?WATCHING & ?ALERT)
17 CVAR: PFMAX        (          ditto            )
18 CVAR: RAWPFMAX     (          ditto            )
19 CVAR: TF
20 CVAR: BUMPX  ( BUMPVEL.X)
21 CVAR: BUMPY  ( BUMPVEL.Y)
22 CVAR: CHKSUM-10  ( used as BUMPZ ????)
23 CVAR: GETSIN            ( function)
24 CVAR: GUYSLEFT
25 CVAR: WEAPONS
26 CVAR: CURWEAPON


27 CVAR: QBLAST  ( qxyblast in pmisc.asm, see new 16-bit ver)
28 CVAR: PYGMYERROR
29 CVAR: ROBODATAOFF       ( stop using this -- fcs)
30 CVAR: PLAYSOUND         ( function)
31 CVAR: KILLERFLAG        ( an array, I think)
32 CVAR: WTH
33 CVAR: IRNDSH            ( number targets hit with bullet )
34 CVAR: ITARGE            ( number guards killed )
35 CVAR: UNIVREGS
36 CVAR: WZ
37 CVAR: REMCFLAG ( not used now.n1=remcontrl avail, -1=active)
38 CVAR: BLASTR            ( function)
( *** new C variables not in original p.c *** )
39 CVAR: QUEUEDMESSAGE



40 CVAR: GLOBEFFECTS       ( an array, I think)
41 CVAR: OTICKS
42 CVAR: MYLOS      ( mylineofsight in myline.asm)
43 CVAR: QXY        ( qwallxy in qwalxy.asm, used in WALLXY?)
44 CVAR: DIFFICULTY ( new integer in p.c ??)
45 CVAR: BLASTA     ( new integer in p.c ?? "blast attribute"?)
46 CVAR: FAILCODE   ( new integer in p.c ?? not used at all?)
47 CVAR: SCORE      ( new integer in p.c ?? not used at all?)
48 CVAR: TNUMFLAG   ( old integer in p.c ?? used?)
49 CVAR: ONE_FRAME  ( function to update video screen)
50 CVAR: DEBUGFLAG  ( use as a condition in the debugger)
51 CVAR: GETHANDLE  ( function )
52 CVAR: QOPENDOOR   ( just to test it from Forth)
53 CVAR: SENDCHEAT   ( sends a collected cheat string from FORTH to c )
54 CVAR: ADSQRT     ( just to test it from Forth)
55 CVAR: OBJHEAD    ( just to test it from Forth)


( VARIABLE WWID  100 WWID !   ( wall width for WALLXY? )
VARIABLE RETCODE
VARIABLE AATAN2PTR        ( for function  AATAN2         )
VARIABLE LOSPTR           ( for function  LINEOFSIGHT    )
( VARIABLE RANDNPTR         ( for functions RANDN & RANDR  )
VARIABLE INV_UTILPTR       ( for function inv_util )
VARIABLE GETSINPTR        ( for functions GETSIN & GETCOS)
VARIABLE PLYSNDPTR        ( for function  PLAYSOUND      )
VARIABLE ONE_FRAMEPTR     ( for function  ONE_FRAME      )
VARIABLE GETHANDLEPTR     ( for function  GETHANDLE      )
VARIABLE MYLOSPTR         ( for function MYLOS           )
VARIABLE QXYPTR           ( for function QXY             )
VARIABLE QXYBLASTPTR      ( for function QXYBLAST ???    )
( VARIABLE NEWPOINTPTR      ( for testing new endpoints routine)
VARIABLE ADSQRTPTR       ( for function ADSQRT )
VARIABLE SENDCHEATPTR     ( for function sendcheat )   
VARIABLE QOPENDOORPTR   ( for function QOPENDOOR ) 



( Set up the interface to the CDECL external functions)
( #in #out   address)
   2    1  AATAN2PTR    CDECL:   AATAN2()  ( x y - angle)
   4    1  QXYPTR       CDECL:  QXYWALL()  ( x y z width - angle)
   5    1  LOSPTR       CDECL:   OLDLOS()  ( x0 y0 x1 y1 0 - f)
   2    1  QXYBLASTPTR  CDECL: QXYBLAST()  ( x y - f)
   0    0  ONE_FRAMEPTR CDECL:       .VGA  ( -)
   3    1  MYLOSPTR     CDECL:    MYLOS()  ( x y relz - f)
   2    0  PLYSNDPTR    CDECL:   PLYSND()  ( sound# volume -)
   1    1  GETSINPTR    CDECL:   GETSIN()  ( angle - sine)
   1    1  ADSQRTPTR    CDECL:     SQRT()   ( u - u)
   1    1  GETHANDLEPTR    CDECL:   GETHANDLE()  ( handle# - objtype# )
   3    1  INV_UTILPTR  CDECL:   INV_UTIL()  ( icode ipick ival - ires )
   1    0  SENDCHEATPTR  CDECL:   SENDCHEAT()  ( stringaddress - )
   3    1  QOPENDOORPTR  CDECL:   QOPENDOOR()  ( x y range - waitflag )
   
: LINEOFSIGHT() ( x0 y0 x1 y1 - f)  0 OLDLOS()  ;
: PLAYSOUND() ( volume sound# -) SWAP PLYSND()  ;
: GETCOS() ( angle - cosine)  16384 + GETSIN()  ;



COMMENT( If GS is executed just once, or never, let's read the
         CMOS in high-level Forth )

: CMOSX  ( index -)  $6F PC!  ;   ( establish location)
: CMOS@  ( index - value)  CMOSX   1 MS   $70 PC@  ; ( read it)
: GS  ( - CMOScksum)
  $2E CMOS@  8 <<< ( ie 256*)  $2F CMOS@  +   ;

CODE NEWPT ( x y length angle - x0 y0 x1 y1)
  b c mov  b pop  d pop  a pop  NEWPOINTPTR #)  di X call
  a push  d push  b push  c b mov  NXT,  END-CODE

)COMMENT















COMMENT(
( Apparently these are byte registers.  UREG@ is not)
( called in this file, but if needed, define with   )
( something like the colon word following           )
CODE UREG@  ( univreg# -- value )
  BX CX MOV,
  DI DI XOR,
  URPTR [DI] BX LES, CX BX ADD,
  ES: 0 [BX] BL MOV, BH BH XOR, NXT, END-CODE

)COMMENT

: UREG@ ( univreg# - value)  UNIVREGS + C@  ;




COMMENT(
( Apparently these are byte registers.  UREG! is not)
( called in this file, but if needed, define with   )
( something like the colon word following           )
CODE UREG!  ( value univreg# -- )
  BX CX MOV,
  DI DI XOR,
  URPTR [DI] BX LES, CX BX ADD, AX POP,
  ES: AL 0 [BX] MOV, BX POP, NXT, END-CODE


)COMMENT

: UREG! ( value univreg# -)  UNIVREGS + C!  ;




COMMENT(

 The size of the weapons structure was 26 bytes in the 16-bit
 version.  It was 11 fields of 2-byte integers followed by a
 4-byte (*char) pointer.  So, in 32-bit Watcom, it becomes
 11*4 + 4  =  48 bytes.

)COMMENT








: WEAPON@  ( field - value)
  ( could use shifts,  2 <<< instead of 4 *             )
  (                and 4 <<< DUP 2* + instead of 48 *   )
  2 <<<  ( 4*)  ( assuming 32-bit integers for each field)
  CURWEAPON @  48 *  +  ( offset)   WEAPONS +   @   ;

COMMENT(    ( fetch a byte from the lampstat array)
 ( This is never used in this file.  If needed,)
 ( use something like [ #] LAMPSTAT + C@      )
CODE LAMP@  ( # - a)
  BX CX MOV,
  DI DI XOR,
  LAMPTR [DI] BX LES, CX BX ADD,
  ES: 0 [BX] BL MOV, BH BH XOR, NXT, END-CODE
)COMMENT


COMMENT(
  ( OR byte value into a byte of the lampstat array)
CODE LAMP|!  ( c # -)
  BX CX MOV,
  DI DI XOR,
  LAMPTR [DI] BX LES, CX BX ADD,
  AX POP,
  ES: AL 0 [BX] OR, BX POP, NXT, END-CODE

)COMMENT






COMMENT(  fcs May98  -- apparently LAMP|! is never
          used, which means lampstat[nlamps] is not
          needed any longer in the C code

         ( OR byte value into a byte of the lampstat array)
         : LAMP|!  ( c # -)  LAMPSTAT + DUP C@ ROT OR SWAP C!  ;

)COMMENT














( The following constants are indexes into the WEAPONS array)
( Each entry in the array is a 4-byte integer)

0 CONSTANT WATTRIB
( 1 CONSTANT WFLUID )
2 CONSTANT WRANGE
3 CONSTANT WDISTOFF
4 CONSTANT WRDENOM
5 CONSTANT WLUCK
6 CONSTANT WFORCE
7 CONSTANT WMAXHIT






COMMENT(

The following USER variables are local to the current robot's
task.  Previously the entire robodata area for all robots
(all 32 of 'em) was copied back to C after every pygmycommand=3
call.  All this mainly so C could find the cl0obj struct for the
associated robot in order to find out its current location.
Also, the BXS and STKA fields were checked to see if Pygmy was
working and whether the robot's deadflag was set.  Instead, when
the C program detects a robot when loading a universe, it stores
a pointer to its cl0obj struct into an array in C named named
'robots[]' and increments a counter.  Then, this array can be
searched to find the cl0obj ptr for each robot so its
co-ordinates can be fetched.

)COMMENT


( USER variables )
( 24) #USER @ ( next available offset for USER variables)
   USER WHOAMI   ( robot number associated with current task)
   USER OBP      ( cl0obj struct pointer belonging to robot)
   USER BXS      ( status)
   USER RBX     ( RBX and RBY are used for what?       )
   USER RBY     (                                      )
   USER RBQK    ( quickness of a robot, referenced as RBTMP)
   USER RBT1    ( timer accumulator for the local task)
   USER RBSP    ( 4 ( speed of a robot -- not used?)
   USER RBTMP6  ( originally at byte offset 6 from RBTMP)
   USER RBTMP8  ( originally at byte offset 8 from RBTMP)
   USER RBHT    ( 12 ( mx hit pts *256 + current hit points )
   USER RBGN    ( 14 ( gun strength* 256 + gun skill )
   USER RBQL    ( 16 rangeval*256 + quality of guard in general)


( USER variables )
   USER RBAL    ( 18 ( current alertness of guard * 256 with)
                ( fractional part )
   USER RBLX    ( 20 ( x value of last seen player )
   USER RBLY    ( 22 ( y value of last seen player )
   USER RBTRN   (  3 **temp location used in turning and dying)
   USER RBTYP   ( 256* zoffset + guard type number )  ( fcs 24May98)
   USER CURDEATH ( changed this to a local variable Feb95)
   USER CURQUAL   ( addr of row in QUALTABLE for this robot)
   USER PFDIFF    ( current profile less PF1               )
   USER DIEFLAG







( USER variables )
   USER RANDLOOPS ( used by RANDOMWALK       )
   USER WINPATH   ( used by LAMBWALK         )
   USER MINDIST   ( used by LAMBWALK         )
   USER TIMER1    ( goal for oticks to reach )
   USER TIMER2    ( goal for oticks to reach )
   USER BEHAVE_CODE    ( initialized in value of cl0tmp3 )
   USER GREG0     ( Variables for script writing )
   USER GREG1     ( Variables for script writing )
   USER GREG2     ( Variables for script writing )
   USER GREG3     ( Variables for script writing )
   USER GREG4     ( Variables for script writing )
   USER GREG5     ( Variables for script writing )
   USER GREG6     ( Variables for script writing )
   USER GREG7     ( Variables for script writing )
 (  DROP  )  #USER !
 ( so, 27 USER variables in this file for a total of 33  )
 ( total, times 4 bytes = 132 bytes per task             )



( Global variables )
 VARIABLE PHLEN  ( delay on enable of playing the hey sound)
 VARIABLE PHW    ( cyclical one to play)
 VARIABLE NSHOTS
 VARIABLE ADVCAP
 VARIABLE ELAPSED   ( # of oticks since last call to callpyg36)
 VARIABLE FPS*10             ( 10 times most recent frame rate)
 VARIABLE LAST-OTICKS   ( value last time callpyg36 was called)



: ATTRBTYP  ( [bit to interrogate] -- [t/f]   Checks a bit of robot type )
   TYPATTR RBTYP @ MAXGT AND #GA * GA-DATA + MOVE.TYPE + C@ CELLS + @ AND  
;

( [GA_OFFSET] -- [VALUE] )
: GA-VALUE
  RBTYP @ MAXGT AND #GA * + GA-DATA + C@
;

( -- [SHOOTSND.RANGE constant ] )
: C_5000
   SHOOTSND.RANGE GA-VALUE 100 *
;

( Currently not called in the PMIN level demo)

: WALLXY? ( x y z - f)   ( x,y are absolute co-ordinates, z is relative to ground )
  ( true if point x,y is inside a wall)
(  WWID @  )
  WIDTH.WIDTH GA-VALUE 10 *
  ( x y z width) QXYWALL()  ;


( Timers)
: ELAPSED!  ( -)         ( update number of oticks per frame)
  ( slower computers will have larger value in ELAPSED )
  OTICKS @  LAST-OTICKS @  OVER LAST-OTICKS !  - ELAPSED !  ;

: FPS! ( -)  728 ELAPSED @  /  FPS*10 !  ;
( If oticks happen at 4 times 18.2 times per second,   )
(  then there are about 73 oticks per second.          )
(  Should I scale by 10?                               )

: TICKS ( # -)  ( wait right here until # oticks have passed )
  OTICKS @ + BEGIN PAUSE  OTICKS @ OVER U> UNTIL  DROP  ;
: SECONDS ( #seconds - #oticks)  73 *  ;
: /SECOND ( Hz - #oticks)  73 SWAP /  ;
: %CHANCE ( percent - f)  1000 *  100000 RANDR  U>  ;
: %CHANCE0000 ( percent - f)  10 *  100000 RANDR  U>  ;  ( 10000 = 100% 100=1% 10=.1% )

( targetpercent0000 - actualpercent0000 )
: chance_test  ( if returns close to 100, it is operating correctly )
   0
   10000 FOR 
     OVER %CHANCE0000
     IF 1+ THEN 
   NEXT
   NIP
;



: TIMER1? ( #oticks - f)
  OTICKS @ TIMER1 @ U> DUP IF OVER OTICKS @ + TIMER1 ! THEN NIP  ;

: TIMER2? ( #oticks - f)
  OTICKS @ TIMER2 @ U> DUP IF OVER OTICKS @ + TIMER2 ! THEN NIP  ;

COMMENT( Removed to make room for behave_code 
: TIMER3? ( #oticks - f)
  OTICKS @ TIMER3 @ U> DUP IF OVER OTICKS @ + TIMER3 ! THEN NIP  ;
)COMMENT

COMMENT(
  Each instance in a task that needs a timer gets its own
  timer.  Start out with 3 timers.  TIMER1, for example, holds
  the goal.  When OTICKS exceeds the goal, TIMER1? returns
  true and increases the goal.  TIMER1 is local to each task.
)COMMENT

: CL0:  ( cl0obj-field# -)  ( - relative-address)
  ( each field in the structure is 4 bytes)
  CREATE  4 * ,  ( convert index number to a byte offset)
  DOES>  @  OBP @  +   ;

 ( previously, we didn't need the first field [at offset 0],)
 (  but as of Feb95, I think we need it for use in (ROBOBUMP)

 0 CL0: CLNEXT         ( pointer to next object in the list)
: LOOKAT ( task -)  OBP SWAP LOCAL @ OBP !  ;
 ( allow main terminal task to view the cl0obj struc of a   )
 (  robot task, eg   T3 LOOKAT                              )
: BECOME ( task -) ( terminal task "becomes" the specified task)
  WHOAMI LOCAL ( from) WHOAMI ( ie to)
  #USER @ 6 CELLS - ( ie #) CMOVE  ; ( e.g  T1 BECOME  )


( define access to the cl0obj struct fields )
 1 CL0: CLST           ( objstatus)
 2 CL0: CLTY           ( objtype)
 3 CL0: CLX0           ( x0)
 4 CL0: CLY0           ( y0)
 5 CL0: CLZ0           ( z0)
 6 CL0: CLTH           ( th)
 7 CL0: CLRX0          ( rx)
 8 CL0: CLRY0          ( ry)
 9 CL0: CLRZ0          ( rz       -- not referenced)
10 CL0: CLRTH          ( rth      -- not referenced)
11 CL0: CLDIST         ( dist)
12 CL0: CLT1           ( cl0tmp1  --  not referenced)
13 CL0: CLT2           ( cl0tmp2)
14 CL0: CLT3           ( cl0tmp3  --  Feb95 now referenced)
15 CL0: CLT4           ( cl0tmp4)

: CLT2! ( n -- ) DUP 0< OVER 255 > OR IF
  ( if clt2 is going negative, then just freeze so we can trace problem. )
    ( Save errant value in winpath )
    WINPATH ! 0 CLT2 ! $40000 CLST !  ( Mark us as crashed. )
    BEGIN PAUSE 0 UNTIL 
  ELSE
    CLT2 !
  THEN ;

COMMENT(

: PTA ( -)  ( does this stand for "print tick array" ?)
  TICKARR  6 FOR ( a) CR  C@+  .   NEXT DROP  ;

( PTA is not currently executed)

)COMMENT









( flag bit positions )
   1 CONSTANT BLKFLAG     ( robot's path is blocked)
   2 CONSTANT INTFLAG     ( guard has been interrupted)
   4 CONSTANT HUNTFLAG    ( guard is in hunt mode)
   8 CONSTANT MISSFLAG    ( didn't get a clear shot)
  16 CONSTANT SERPDIR     ( serpentine direction)
  32 CONSTANT CHARGEFLAG  ( keep attack going despite wounds)
  64 CONSTANT PANICFLAG   ( running away in panic)
 128 CONSTANT RUNFLAG     ( running right now)
 256 CONSTANT DEADFLAG    ( guard is dead)
 512 CONSTANT LAMBFLAG    ( guard is in lll mode)
1024 CONSTANT RECYCLEFLAG ( recycle this guard)

  ( continued )



 512 CONSTANT BITREMC
( remote control flag -- added in PMIN, but I don't think )
(  should be needed, as we are ditching the remote control)
(  stuff)

2048 CONSTANT GUYFLAG ( don't count this guy as an alive guard)
4096 CONSTANT ARMORFLAG ( armored guys aren't affected by )
                        (  non-lethal weapons)

8192 CONSTANT MURDERFLAG ( if this guy dies,     )
                         (   it is player's fault)

16384 CONSTANT KOEDFLAG ( flag that scored already )
                        (   for ko'ing this guard  )
32768 CONSTANT INVULNFLAG ( If set, guard is invulnerable to weapons firing )
$10000 CONSTANT NOATKFLAG ( If set, guard will not attack unless provoked )
$20000 CONSTANT NODEFENDFLAG ( If set, guard will not fight back for any reason. )
$40000 CONSTANT EXPROOFLAG ( If set, guard is explosion proof )
$80000 CONSTANT NOCURIOUSFLAG ( If set, guard is not curious, and will not approach player )
$100000 CONSTANT BEENCLOSEFLAG ( If set, guard has been close before )



( BIT@   BIT!    -- previously named ROBOSTAT@   ROBOSTAT!  )
( gets value of specified status bit )
: BIT@ ( robostatusbit - bitvalue)  BXS @ AND 0= 0=  ;

( sets or clears value of specified status bit )
: BIT! ( bitvalue robostatusbit -)
  SWAP OVER AND  ( robostatusbit new-bit-value)
  SWAP -1 XOR BXS @ AND  ( clear the bit)  OR  BXS !   ;


( Be careful!  Status bits can only be accessed by the task )
( that owns BXS )





( ROBOMAINTAIN )
DEFER ROBOMAINTAIN
DEFER ROBODEATH
DEFER ROBOSHOOT


DEFER CALL_BEHAVIOR
( robomaintain points to the default word (rmtn. )











( new stuff Feb95)
1 CONSTANT BITRECOVERABLE  ( Can recover from death )
2 CONSTANT BITPRETURN  ( If this bit and only this bit is set, do a fast turn before death )
4 CONSTANT BITVIBRATE  ( Set this bit if we are supposed to respond to tear gas )
8 CONSTANT BITLONGWAIT ( Set this bit to make KO last longer. )
16 CONSTANT BITCANCELDEATH (  Causes death sequence to not run.  Use to stop GOO or KO death )








COMMENT(

  Task switching is accomplished by the word PAUSE, if
  PAUSE points to the word (PAUSE.  The words SINGLE and MULTI
  determine whether PAUSE will execute (PAUSE or NOP.
  All we need to do to allow each robot task to execute is to
  execute PAUSE in the main terminal task, to give each other
  active routine a chance to run, then return to the C program.

)COMMENT







( STRTROBOTS )
VARIABLE ANYBODY  ( count how many robots see the player)
: STRTROBOTS  ( -)
  ROBOMAINTAIN   RETCODE OFF ( ANYBODY OFF)  PAUSE
  ( ANYBODY @ U. CR)  RETCODE @ #BYE  ;

COMMENT(
 This is the heart of the system.  When C causes Forth
 to execute, with callpyg36, STRTROBOTS gets invoked.  It
 does ROBOMAINTAIN to handle any global processing, then does
 PAUSE to give all the other tasks a chance to execute.  When
 they finish and execution once again returns to STRTROBOTS,
 it returns RETCODE to C.
)COMMENT




8 CONSTANT NRANGES
2 CONSTANT NB/RANGE

CREATE RANGETABLE    ( NRANGES NB/RANGE * ALLOT )
16000 W,  8000 W,  4000 W,  2000 W,
 1000 W,   750 W,   500 W,   280 W,

: RANGETABLE@ ( - u)
  RBQL @ 8 >>> 7 MIN  0 MAX  2*  RANGETABLE + W@  ;







: QT,  ( put one set of entries into the qualtable)
  ( hwhm2 angsf adistmx adclip adsf adrnd defalert almv -)
  8 FOR  W,  NEXT  ;

CREATE QUALTABLE

( HWHM2  ANGSF  ADISTMX  ADCLIP  ADSF  ADRND  DEFALERT  ALMV )
  512    512    2000     3500    768   0      16 256 *  20  QT,
 1024    512    2000     3500   2000   0      50 256 *  20  QT,
 1024    512    4000     3500   2000   0     100 256 *  20  QT,
 1024    512    4000        0   2000   0      20 256 *  20  QT,
 ( last entry will never attack)

( USER variable CURQUAL must hold address of one of the 4 lines
  in the above table )


 4 CONSTANT NQUALS
16 CONSTANT NB/QUAL

: QUAL: ( offset -) ( - value)
  CREATE C, DOES> C@ CURQUAL @ + W@  ;

14 QUAL: HWHM2
12 QUAL: ANGSF
10 QUAL: ADISTMX
 8 QUAL: ADCLIP
 6 QUAL: ADSF
 4 QUAL: ADRND
 2 QUAL: DEFALERT  ( default alert value -- related to RBAL)
 0 QUAL: ALMV  ( alert momemtum, helps adjust RBAL)


( CLDIST is now set to garbage, so we must make up our own distance. )

: DIST ( dX dY - u)    DUP * SWAP DUP *  +  SQRT()  ; 

: NCLDIST 
  WX @ CLX0 @  - CLY0 @  WY @ -  DIST ;


COMMENT(  Let's make a faster one
: RBDIST  ( - dist)  NCLDIST ;
)COMMENT

: RBDIST
  WX @ CLX0 @  - CLY0 @  WY @ -  DUP * SWAP DUP *  +  SQRT()  ; 

( returns range info of guard to player.  min range is 200 )
: RBRANGE ( - range)  RBDIST 200 + ;

( leaves angle 0-65535 pointing at player )
: AIMANGLE  ( - angle )
  WX @ CLX0 @  -  ( relativeX)  ( kds jun98 reverse x coordinate to make it work. )
  CLY0 @  WY @ -  ( relativeX relativeY)  AATAN2()  ( angle) 32768 + 65535 AND ;



: GETRBVOLUME
  RBDIST PUSH
    R@ 800 < IF 63 ELSE  ( If less than 800 units away, volume is full blast )
      R@ 2400 < IF   
        1600 R@ 800 - - 15 * 1600 / 48 +  ( at 2400 units, volume is down to 48, which is less that 1/2 )
      ELSE
        4000 R@ 2400 - 4000 MIN - 48 * 4000 /  ( at greater distances, there is almost no sound. )
      THEN
    THEN
  POP DROP
;




( New version, using mylineofsight in myline.asm )
( leaves true flag if robot has a clear shot at player )

: ROBOCLEARSHOT?  ( - f)
  CLX0 @  CLY0 @  CLZ0 @ MYLOS() 0= ;    ( kds jun98 changed because rel coordinats are garbage. )

COMMENT(
: ROBOCLEARSHOT?  ( - f) 1  ( FOR TESTING ) ;
)COMMENT

  ( mylineofsight returns true if path blocked, so we need 0= )
  ( Note, above uses robot's relative co-ordinates.)










COMMENT(
   per Feb95, this is no longer used
  ( leaves true flag if robot has a clear shot at player )
: ?ROBOSURESHOT  ( - f)
    0 ( assume false)
       CLST  @ 16 AND 0=
       IF
         WY @ WX @ CLY0  @ CLX0  @ LINEOFSIGHT() 0=
         CLY0  @ CLX0  @ WY @ WX @ LINEOFSIGHT() 0= AND
         ( why check both ways??? does it make a difference???)
         OR  ( possibly alter original flag)
       THEN ;

)COMMENT



( returns true if poisoncheck returns address and path clear)
: ROBOPOISONED? ( - f)
    CLX0 @  CLY0 @  POISONCHECK ( address | 0)
    DUP ( addr|0  addr|0)
    IF  ( address)
        DUP SW@ ( ie X) SWAP 2+ SW@ ( ie Y)  ( otherX otherY)
        CLX0 @  CLY0 @ ( x y robotX robotY) LINEOFSIGHT()  0=
        ( leave los result if poison )
    THEN  ( flag)  ;
COMMENT(  Should this switch over to using MYLOS()?  No, because
 it must see whether the path is clear between two arbitrary
 points, whereas MYLOS() checks between one abitrary point and
 the player's location.  LINEOFSIGHT() returns true if the path
 is blocked.
)COMMENT


: GETCLIP ( - alert_distance)
   ADISTMX ( ie maximum_alert_distance??)
   RBAL @           ( ie current_alert_value)
   DEFALERT  DUP PUSH  ( ie default_alert_value)
   16383 MIN    ( ie clipped_default_alert_value)
   2* ( ie doubled_clipped_default_alert_value)
   ( mx curr double_default) MIN  ( mx  lesser_curr_or_dbldef)
   POP  ( mx lesser virgin_default)
   ( don't expand over a factor of two )     P*/
   ( basically, multiply max by ratio of current to default, )
   (   but not with a ratio greater than 2                   )
   RBDIST - 0 MAX ADCLIP MIN ;

( This returns a key value used in ?ALERT to calculate the )
( Player's profile.                                        )



: GETRADIAL ( - u)
   AIMANGLE CLTH @ -  SX ( get relative angle to player)
   ABS ANGSF U/ DUP * HWHM2 + ;

( 1024 when facing Player, 5120 when back is toward Player )
( The worse the angle for seeing the Player the higher the )
( number returned.  See ?ALERT where GETRADIAL serves as a )
( denominator for calculating the Player's profile         )








( UPDATEAL   "update altert value"   )
: UPDATEAL  ( - )
  ( update's robot's alert value by relaxing to default value)
  NSHOTS @ IF $7FFF RBAL ! THEN
         ( raise alertness if shot rings out )
   ( 3) ( 2) 10 /SECOND TIMER1? IF
         ( do this for every 3 second )
      DEFALERT RBAL @ -  ( get difference from default )
      ALMV DUP 0= IF
       RBQL 0 /  ( Generate 0 divide )
       BEGIN PAUSE 0 UNTIL 
      ELSE
        UP @ RBTMP6 !  ( Save user pointer in variable for later inspect )
      THEN / RBAL +!
  THEN ;
COMMENT(
      ALMV stands for "alert momentum".  Apparently UPDATEAL
raises alert value to $7FFF if there were shots, otherwise, it
gradually walks alert value back down to the default value.
)COMMENT



: (RMTN ( - )               ( does guard maintainence )
  ELAPSED!  ( FPS! )
  AVGTIME @ 4 / 2+ RANDR PHLEN @ + 10000 MIN PHLEN !  (   )
  ( above: advance timing stuff)
  ( 3000 AVGTIME @ - 3000 RANDR < )
  [ 10 /SECOND ] LITERAL TIMER1?
  IF   ( do this for every 3 second )
       NSHOTS @ 2/ NSHOTS !
  THEN  (   )
  AVGTIME @ ADVCAP +!
  ADVCAP @ 2000 >  IF  ADVANCEPOISON  0 ADVCAP !  THEN  ;

' (RMTN IS ROBOMAINTAIN
( This gets called via ROBOMAINTAIN in STRTROBOTS)



: URF  ( - ) ( uppdate runaway flag )
     RBHT @ 256/ 3 / 1 MAX  RBHT @ 255 AND 1- >
     PANICFLAG BIT! ;




( This uses the original logic)
COMMENT(
: WATCHING? ( - f)
  ( returns a true value if guard paying attention )
    RBAL @ 256/
    PFDIFF @  PF1 @  P*/    PFDIFF @  PF1 @  P*/
    ( above scales twice by the same ratio) 800 MIN
    AVGTIME @ 1000 MIN 30 P*/ 10000 MIN 10000 SWAP -
    10000 RANDR <  ;

 (  ie, answer whether, ignoring MINs,                       )
 ( 10000 - [RBAL/256]*[pfdiff/pf1]*[pfdiff/pf1]*[avgtime/30] )
 ( is less than some random number                           )

)COMMENT


( Base WATCHING? on a percentage adjusted by RBAL and PFDIFF )

: WATCHING? ( - f)
 ( returns a true value if guard paying attention )
 ( Stupidest guard must notice something 20% of the time?)
 ( Let RBAL control 40%.  Let PFDIFF control 40%  )
 0  ( default flag is false)
 [ ( 6) 3 /SECOND ] LITERAL TIMER2? IF  ( f) DROP
    20           ( base percentage for even stupidest guard)
    20 RBAL @ 256/ 256  P*/  +         ( up to 45% for RBAL)
    20 PFDIFF @  PF1 @  P*/  20 MIN +  ( up to 35% for RBAL)
    ( percentage) %CHANCE  ( f)
 THEN  ( f)  ;
( PFDIFF can be much smaller than PF1 or up to 5 times larger )




: PLAYHEY! ( -)
  ( play sound of guard yelling hey! )
  ARMORFLAG BIT@ IF   EXIT   THEN
  HEY.START GA-VALUE 0= IF EXIT THEN
  PHLEN @ 10000 RANDR AVGTIME @ + > NOT IF  EXIT   THEN
(  16383 RBDIST 10 / 260 MAX / )
  GETRBVOLUME
  1000 RANDR 700 < IF ( see if normal sound cyclical order)
     PHW @  ELSE
     (   4  )
     HEY.END GA-VALUE HEY.START GA-VALUE - 1 +
     RANDR DUP PHW ! ( nope, use random sound)
  THEN
  HEY.START GA-VALUE + PLAYSOUND()
  PHW @ 1+ 3 AND PHW !  ( advance to next sound)
  0 PHLEN !   ;






: PLAYAHG!    ( play sound of guard yelling ouch! )
  DIESND.START GA-VALUE 0= IF EXIT THEN
  ARMORFLAG BIT@ 0=
  IF
(  16383 RBDIST 10 / 260 MAX / )
  GETRBVOLUME
    (  4  )
      DIESND.END GA-VALUE DIESND.START GA-VALUE - 1 +
      RANDR DIESND.START GA-VALUE +
  ELSE
      63 DIESND.START GA-VALUE  ( sound of hovercraft exploding)
  THEN
  PLAYSOUND()   ;








COMMENT(   this word dropped in Feb95 version
: ?NAPALERT ( - )  ( sets intflag if napping soldier sees guy)
 PANICFLAG ROBOSTAT@ HUNTFLAG ROBOSTAT@ AND IF EXIT THEN
 ( RBQL @ 255 AND NB/QUAL * CURQUAL !)
 RBDIST 5000 <  IF  UPDATEAL
     GETCLIP ADSF HWHM2 P*/
     DUP DUP RAWPFMAX @ MAX RAWPFMAX !
     PF1 @ > IF  ?ROBOCLEARSHOT
                IF DUP PF1 @ - PFDIFF !
                   PFMAX @ MAX PFMAX !
                   ?WATCHING
                   IF  HUNTFLAG ROBOSTAT@ 0=
                      IF  -1 INTFLAG ROBOSTAT!  PLAYHEY!  THEN
                   THEN
                ELSE DROP THEN
             ELSE DROP THEN               THEN   ;   )COMMENT

 ( CODE ANGTOLAMP  ( angle - lamp#)
 ( dividing by 2260 -- does this                 )
 ( mean there are lamps numbered 0 to 28?        )

: ANGTOLAMP ( angle - lamp#)
  $FFFF AND   2260 /  ;


VARIABLE LAMPVAL
 ( this used only within ?ALERT and does not need to survive )
 (   across a PAUSE, so no need for it to be a USER variable )





( : ?ALERT ; )

( This uses the original logic)
 : ?ALERT   ( -)  ( sets intflag if soldier sees guy )
 NOCURIOUSFLAG BIT@ IF  ( If guard is not curious, then refuse to interrupt activities )
   EXIT
 THEN
 PANICFLAG BIT@ HUNTFLAG BIT@ AND   IF  EXIT  THEN
 RBDIST 5000 <   NOT                IF  EXIT  THEN    (   )
 UPDATEAL GETCLIP ( alert_distance) ADSF GETRADIAL
 ( alert_distance adsf anglefactor)  P*/  ( profile)
 DUP DUP ( pf pf pf) RAWPFMAX @ MAX RAWPFMAX !  ( pf pf)
 PF1 @ > ( pf f) ROBOPOISONED? OR INTFLAG BIT@ 0= AND ( pf f)
 IF ROBOCLEARSHOT?  ( pf f)
    IF WX @ RBLX !  WY @ RBLY !  ( pf)
       DUP PF1 @ - PFDIFF ! ( pf) DUP PFMAX @ MAX PFMAX ! ( pf)
       WATCHING? IF  HUNTFLAG BIT@ 0=
                   IF 
                     -1 INTFLAG BIT!  
                     CDALERT CALL_BEHAVIOR
                     INTFLAG BIT@ IF
                       PLAYHEY! 
                     THEN
                   THEN
         THEN  ( pf)
     THEN ( pf)
 THEN ( pf) DROP   ;

( Simplified ?ALERT used for testing)
COMMENT(

: ?ALERT ( -)
  PANICFLAG BIT@ HUNTFLAG BIT@ AND   IF  EXIT  THEN
  RBDIST 1500 > IF  EXIT  THEN
  WATCHING? NOT IF  EXIT  THEN
  ROBOCLEARSHOT?  ( f)
  IF  WX @ RBLX !  WY @ RBLY !
      HUNTFLAG BIT@ 0= IF  -1 INTFLAG BIT!   PLAYHEY!  THEN
  THEN   ;

)COMMENT




( CHECKRANGE?)


: CHECKRANGE? ( - f)
  ( returns true if close enough to consider interrupting )
  ( activity to take a shot )
  RBRANGE ( dist+200)
  1000  RANGETABLE@  MIN  ( dist+200  rangetable@)   <  ;

COMMENT(
  Currently RANGETABLE@ will always return the first entry, as
  the PMIN demo does not set the upper byte of RBQL.  If we
  knew this would _never_ be set, we could simplify the above
  logic or the word RANGETABLE@. The first entry in RANGETABLE
  is now 16000, so the MIN will ALWAYS be 1000.    )COMMENT



: KILL-TIME ( time -)
  BEGIN PAUSE AVGTIME @ - DUP 0< UNTIL DROP   ;

: RANDRANGE ( low high - rand# )
  ( returns a random number in a certain range )
     OVER - RANDR +  ;

COMMENT(  following reduces frame rate too much, don't use it
: WAITED? ( time-to-kill - f)
  AVGTIME @ RBT1 +!  ( increment the local time accumulator)
  RBT1 @ SWAP ( so-far  time-to-kill) U>  ( flag)
  DUP IF RBT1 OFF THEN  ;
 ( Increment the time accumulator and see whether we have
   waited long enough yet.  If so, reset the time accumulator.)
 )COMMENT

(  guard turns in sentry position until in correct direction )
: FASTTURNUNTIL ( desired-angle -)
  TURN.START GA-VALUE CLT2!  ( sentry the guy)
  DUP CLTH @ - ( goal diff)   SX
  DUP ABS 4096 / ( goal diff #steps)
  
  DUP 1 > IF ( If we are going to make more than one step, call behavior )
     RBDIST MAX_WALK_SENSE < IF
       RBDIST MAX_MEET_DIST < IF
         CDMEET CALL_BEHAVIOR
       ELSE
         0 BEENCLOSEFLAG BIT!  ( Reset the BEENCLOSE flag so we can approach again )
       THEN
       CDTURN CALL_BEHAVIOR
     THEN
  THEN
  4096 ROT ( goal #steps stepsize diff)
  0< IF NEGATE THEN SWAP  ( goal stepsize #steps)
  FOR ( goal stepsize)
    DUP CLTH +!   ( ie bump the angle)
    RBQK @ 2/ 2/ 2/ 1+  ( ie time)
    FASTTURN.DELAY GA-VALUE * 10 /
    KILL-TIME ( goal stepsize)

    ( Advance to next standing frame. )
    CLT2 @ 1+ TURN.END GA-VALUE > IF 
      TURN.START GA-VALUE CLT2! 
    ELSE  
      CLT2 @ 1 + CLT2! 
    THEN 
  NEXT DROP ( goal)  CLTH ! (   )
  ( 4 CLT2! )  ( un-sentry the guy)  ;
 ( Note, we divide RBQK by an extra factor of 4         )
 ( instead of multiplying avgtime by that factor of 4.  )



(  guard turns in sentry position until in correct direction )
: TURNUNTIL ( desired-angle -) ( $FFFF AND )
  TURN.START GA-VALUE CLT2!  ( ie sentry the guy)  ( goal)
  DUP CLTH @ ( $FFFF AND)  - ( goal diff) SX
  DUP  ABS 4096 / ( goal diff #steps)
  DUP 1 > IF ( If we are going to make more than one step, call behavior )
     RBDIST MAX_WALK_SENSE < IF
       RBDIST MAX_MEET_DIST < IF
         CDMEET CALL_BEHAVIOR
       ELSE
         0 BEENCLOSEFLAG BIT!  ( Reset the BEENCLOSE flag so we can approach again )
       THEN
       CDTURN CALL_BEHAVIOR
     THEN
  THEN
  4096 ROT ( goal #steps stepsize diff)
  0< IF NEGATE THEN SWAP
  ( goal stepsize #steps)
  FOR ( goal stepsize)
    DUP CLTH +!   ( ie bump the angle)
    RBQK @ 2/ 1+  ( ie time) 
    TURN.DELAY GA-VALUE * 10 /
    KILL-TIME ( goal stepsize)

    ( Advance to next standing frame. )
    CLT2 @ 1+ TURN.END GA-VALUE > IF 
      TURN.START GA-VALUE CLT2! 
    ELSE  
      CLT2 @ 1 + CLT2! 
    THEN 
  NEXT DROP ( goal)  CLTH ! (   )
  ( 4 CLT2!  ) ( un-sentry the guy)  ;

( ** note, KILL-TIME contains PAUSE )


( new Feb95)
: CHOSEDEATH ( u -) ( Takes a weapon attribute and sets the curdeath variable )
  DUP 2 AND IF  DROP  2 ( teargas)       CURDEATH !  EXIT  THEN
  DUP 4 AND IF  DROP  1 ( stickygun)     CURDEATH !  EXIT  THEN
      8 AND IF        3 ( kick or k0gas) CURDEATH !  
            ELSE
                      0 ( default)       CURDEATH !
            THEN  ;











( new version, uses QYXBLAST routine in pmisc.asm)
: BLAST? ( - f)  ( returns a true if soldier dies in blast )
   EXPROOFLAG  BIT@ 0= IF ( See if guy is explosion proof first )
     0 DIEFLAG !
     CLX0 @  CLY0 @  QXYBLAST() IF  1 DIEFLAG !  THEN
     DIEFLAG @ DUP
     IF  0 MURDERFLAG BIT!
         ( if guy dies in exp, it's not our fault)
         BLASTA @  CHOSEDEATH
         ( chose the death that's right for you)
     THEN
   ELSE
     0
   THEN  ;

COMMENT( 
: BLAST? ( - f)  ( returns a true if soldier dies in blast )
   0 DIEFLAG !
   0 ( always return a false ) ;
)COMMENT






COMMENT( old version : ?DEATH  ( returns a true if guy gets it)
   0 DIEFLAG !  CLST  @ 2048 AND
   IF  WRANGE WEAPON@  RBRANGE WDISTOFF WEAPON@ + 0 MAX
       WRANGE WEAPON@ MIN -  WLUCK WEAPON@ DUP RANDR
       SWAP RANDR * + WRDENOM WEAPON@ /  0= NOT
       IF  1 IRNDSH +!  ( incr c variable of number hits)
           AIMANGLE CLTH  @ - ABS 13 >>> ( n)
           RBHT @ 255 AND  RUNFLAG ROBOSTAT@ ( n f)
           ( up hit points if shooting in the back)
           IF  1+ 2 MAX  ELSE  DUP * 1+ 6 MAX  THEN
           WFORCE WEAPON@ RBRANGE P*/ 1 MAX
           WMAXHIT WEAPON@ MIN - 1 ( fleshwound) OVER 1- 0<
           IF  ( really 0<=) 2DROP 0 -1 ( hitpts death)
           THEN  DIEFLAG !  RBHT C!
       THEN     THEN   DIEFLAG @ ;
)COMMENT

( utilities for DEATH?)

: CLEAR-BITSHOT ( -)  2048 -1 XOR  CLST @ AND  CLST !  ;

: SHOT? ( - f)  CLST @  2048 AND  ;

( Sees if weapon can do damage to player, ie check range, and luck and offset, etc )
: TESTZZZ?  ( - f)  ( do we really need a canonical flag?)
  WRANGE WEAPON@  RBRANGE WDISTOFF WEAPON@ + 0 MAX
  WRANGE WEAPON@ MIN -  WLUCK WEAPON@ DUP RANDR
  SWAP RANDR * + WRDENOM WEAPON@ /  0= NOT    ;  ( name it???)







( utilities for DEATH?)
: HIT-POINTS ( -)
  RBHT @ 255 AND ( n)  ( assumes 1 shot = 1 hitpoint)
  AIMANGLE  CLTH @ -  SX  ABS 13 >>> ( n angle-difference)
  RUNFLAG BIT@ ( ie hit-in-back?or-not?)
  ( up hit points if shooting in the back)
  IF ( n n) 1+ 2 MAX  ELSE ( n n)  DUP * 1+ 6 MAX  THEN  ( n n')
  WFORCE WEAPON@ RBRANGE P*/ 1 MAX  ( n n')
  WMAXHIT WEAPON@ MIN ( n n')
  DIFFICULTY @ DUP *  3 +  * 3 / ( make stronger shot for wimps)
  ( n n')  -  ( hitpoints)
  DUP 1- 0< WATTRIB WEAPON@ $0E AND OR ( ie 0<=)
  IF 
    DROP 0 ( points)  WATTRIB WEAPON@ CHOSEDEATH -1  ( p d)
  ELSE  
    ( p)  1 ( ie only a flesh wound)  ( p d)  
    CDWOUND CALL_BEHAVIOR
  THEN
  DIEFLAG !  ( hitpoints)  RBHT !  (   )    ;



: DEATH?  ( - f)  ( returns a true if guy gets it )
                  ( 1=flesh wound;  -1=death)
   0 DIEFLAG !
   SHOT?
   IF  
     CLEAR-BITSHOT
     NODEFENDFLAG BIT@ 0= IF
       NOATKFLAG BIT@ IF
         1 SHOT_A_FRIENDLY +! ( leave flag that player shot at a neutral character )
       THEN
       0 NOATKFLAG BIT!  ( If player attacks us, we can turn mean )
     THEN
       TESTZZZ? ( f)   ( *** waiting on a better name *** )
       IF  1 IRNDSH +!  ( incr c variable of number hits)
         INVULNFLAG BIT@ 0= IF
           HIT-POINTS
         THEN
       THEN
   THEN
   DIEFLAG @  ( f)  ;




COMMENT(  ( replaced Feb95 with following block)
: ROBORELEASE  ( release guy as species 2 pickupable object )
   CLST @ 64 OR  CLST !  ( make it possible to step over guys) 
   CLST @  2 OR  CLST !  ( make object pickupable )
   -1 GUYSLEFT +!        ( now actually flag guy as dead )
   BEGIN  CLST @  1024 AND NOT
       IF  CLT4 @  ?DUP
           IF  2 16 <<< + CLTY  !  ( metamorph into sym object )
               CLST  @ $FFFD AND CLST  !
               200 CLZ0  !
           THEN
           BEGIN  ( ROBOSAVE&EXIT)  PAUSE  AGAIN
       THEN
       PAUSE
   AGAIN ;
)COMMENT



: ROBORELEASE  ( release guy as species 2 pickupable object )
   (  do we need to change status, etc. as on prev version?)
   ( now actually flag guy as dead )
   -1 GUYSLEFT +!   CLST @ BITROBODEAD OR CLST ! ( Mark robot as newly killed. )
    STOP   ;
   ( Original version cleared the radar bit, but currently )
   (  guards do not have a radar bit set for them.         )
   ( What about the metamorph into a sym value?            )





: DEATHATTR
    DEATH.FLAGS ( For default case, leave normal death attribute index on TOS )
    CURDEATH @ 1 = IF
      DROP GOO.FLAGS
    THEN
    CURDEATH @ 2 = IF
      DROP COUGH.FLAGS
    THEN
    CURDEATH @ 3 = IF
      DROP KO.FLAGS
    THEN
    GA-VALUE  ( Turn index into stored value for this particular guy )
;

: DEATHSCORE
    DEATH.SCORE ( For default case, leave normal death attribute index on TOS )
    CURDEATH @ 1 = IF
      DROP GOO.SCORE
    THEN
    CURDEATH @ 2 = IF
      DROP COUGH.SCORE
    THEN
    CURDEATH @ 3 = IF
      DROP KO.SCORE
    THEN
    GA-VALUE  ( Turn index into stored value for this particular guy )
;



( new Feb95)
: PREDEATH ( -)
  DEATHATTR BITPRETURN =
  IF   AIMANGLE FASTTURNUNTIL   THEN  (   )
  PLAYAHG! ( play death song of guard)
;

: SET-FIRST-FRAME ( -)
    DEATH.START   ( For default case, leave normal death start on the tos )
    CURDEATH @ 1 = IF
      DROP GOO.START  
    THEN
    CURDEATH @ 2 = IF
      DROP COUGH.START  
    THEN
    CURDEATH @ 3 = IF
      DROP KO.START  
    THEN
    GA-VALUE CLT2!  ( 1st frame of dying man)  ;

: LAST-FRAME ( - frame# )    
    DEATH.END  ( For default case, leave normal death end on the tos )
    CURDEATH @ 1 = IF
      DROP GOO.END  
    THEN
    CURDEATH @ 2 = IF
      DROP COUGH.END  
    THEN
    CURDEATH @ 3 = IF
      DROP KO.END  
    THEN
    GA-VALUE  ;
    
 : IS_LAST_FRAME? ( - t/f )
    CLT2 @   
    LAST-FRAME 1 - > ;
   
 : BEYOND_LAST_FRAME? ( - t/f )
    CLT2 @
    LAST-FRAME > ;

: ?SET-FIRST-FRAME ( -)
    BEYOND_LAST_FRAME? IF  SET-FIRST-FRAME  THEN  ;



( new Feb95)
: DEATHFALLDOWN ( -)
  SET-FIRST-FRAME  ( 1st frame of dying man)  (   )
  BEGIN    RBQK @ 
       DEATH.DELAY GA-VALUE * 10 /
       KILL-TIME   
       RATHOVER ATTRBTYP RATFLY ATTRBTYP OR IF  
         ( BRING DOWN TO FLOOR IF HOVERING )
         CLZ0 @ 40 + 0 MIN CLZ0 !
       THEN
  
  1 CLT2 @ + CLT2!  IS_LAST_FRAME? UNTIL
    RATHOVER ATTRBTYP RATFLY ATTRBTYP OR IF  
      0 CLZ0 !  ( MAKE SURE TOTALLY ON FLOOR )
    THEN
  CURDEATH @ 0=   MURDERFLAG BIT@  AND
  IF  1 ITARGE +!  ( ie increment number dead)  THEN (   )  ;

COMMENT(
  Change above to keep value to store into CLT2 on stack, and
  thus eliminate the overhead of calling LAST-FRAME? perhaps.
)COMMENT






( new Feb95)
: DEATHGETUP ( -)
  SET-FIRST-FRAME ( 1st frame of dying man)    ;














( new Feb95)
: DEATHDELAY ( -)
  RECYCLEFLAG BIT@
  IF   40   ELSE   -1 DEADFLAG BIT!   8  THEN  ( delay)
  ( ie delay longer if recycling)
  200 AVGTIME @  P*/  1+  ( #frames)
  FOR   PAUSE   NEXT    ;

( can we use KILL-TIME in above? )








( new Feb95)
COMMENT(
( Are we trying to spread out the distance the guard must be
  moved to lower him to the floor over 8 frames?  For now, since
  each task gets control exactly once per frame, could we do
  something like the following?     )COMMENT
: DEATHSINK ( -) CLZ0 @ NEGATE 8 /   ( distance-per-frame)
  8 FOR PAUSE  ( n) DUP CLZ0 +! NEXT ( n) DROP  0 CLZ0 ! ;
COMMENT(  straightforward conversion below doesn't make sense
          to me, so I've rewritten it above
: DEATHSINK ( -)
  40  200  AVGTIME @  P*/  1+  ( #frames to delay)
  FOR   40 200 AVGTIME @ P*/ DUP I -  SWAP 100 SWAP  P*/
        CLZ0 !  ( move body down into floor)
        PAUSE
  NEXT  ;       )COMMENT

( new Feb95)
: UNDEATH ( -)
  -1 DEADFLAG BIT!
  CLST @  $FFBF AND  CLST !
  ( make return guys to bumpable objs)
  STOP   ;


: SET-ARMORED ( -)  -1 ARMORFLAG BIT!  ;
: SET-UNARMORED ( -)  0 ARMORFLAG BIT!  ;
: ARMORED? ( - f)  ARMORFLAG BIT@  ;






( new Feb95)
: DEATHVIBRATE ( -)   SET-UNARMORED
  ( already sb zero because armored things can't be gassed)
  SET-FIRST-FRAME
  BEGIN  RBQK @ 
    DEATH.DELAY GA-VALUE * 10 /
    KILL-TIME  1 CLT2 @ + CLT2!
    BLAST? IF  BLASTA @ 2 AND 0= IF  SET-ARMORED  THEN  THEN 
    WFORCE WEAPON@ 0= NOT 
    IF DEATH? IF SET-ARMORED THEN  ELSE  CLEAR-BITSHOT  THEN 
    BEYOND_LAST_FRAME? IF SET-FIRST-FRAME  THEN
    RBTRN @ 1- DUP RBTRN ! 0=   ARMORED?   OR
  UNTIL  (   )  ;

( Perhaps above should accept the RBTRN value as an argument )
( instead of having it passed in RBTRN??                     )




: DEATHHANGOUT ( -)
  LAST-FRAME CLT2!
  SET-UNARMORED
  ( already sb zero because armored things can't be gassed)
  BEGIN
    RBQK @ KILL-TIME ( this was effectively a nop? )
    BLAST? IF  BLASTA @ 0= IF  SET-ARMORED  THEN THEN
    RBTRN @ 1- DUP RBTRN ! 0=   ARMORED?   OR
  UNTIL  (   )  ;

( Perhaps above should accept the RBTRN value as an argument )
( instead of having it passed in RBTRN??                     )





( used in (ROBODEATH      )
: RECOVERABLE-DEATH ( -)
  100  DEATHATTR BITLONGWAIT AND IF 400 + THEN  RBTRN !
  DEATHATTR BITVIBRATE AND
  IF DEATHVIBRATE ( rub their eyes then return)
     ARMORED? IF  CURDEATH @ ROBODEATH ( ie recurse) THEN
  ELSE
    -1 DEADFLAG BIT!
     DEATHFALLDOWN  DEATHHANGOUT  DEATHGETUP
     0 DEADFLAG BIT!
     ARMORED? IF  SET-UNARMORED  0 ROBODEATH ( ie recurse)
              ELSE  CLEAR-BITSHOT
              THEN
  THEN    ;



( used in (ROBODEATH      )
: RECOVERABLE? ( - f) DEATHATTR BITRECOVERABLE AND  ;

: RECYCLABLE? ( - f)  RECYCLEFLAG BIT@  ;

: NON-RECOVERABLE-DEATH ( -)
    DEATHFALLDOWN 
   CLST @ 64 OR  CLST !  ( make it possible to step over guys) 
     DEATHDELAY
    RECYCLABLE?
    IF
         DEATHSINK
         UNDEATH
    ELSE
         CDKILL CALL_BEHAVIOR
         ROBORELEASE  ( this is the end of the road)
    THEN   ;



: (ROBODEATH ( dth -)
  CURDEATH !
  KOEDFLAG BIT@ 0=
  IF
    DEATHSCORE SIGN-EXTEND-BYTE SCORE +!
    -1 KOEDFLAG BIT! ( mark as already scored w/ this guy)
  THEN
  PREDEATH
  RECOVERABLE?
  IF  RECOVERABLE-DEATH   ELSE   NON-RECOVERABLE-DEATH  THEN
  SET-UNARMORED   ;

' (ROBODEATH IS ROBODEATH
( note RECOVERABLE-DEATH and NON-RECOVERABLE-DEATH call
  ROBODEATH, so recursion is handled by DEFERing ROBODEATH )


( used in  ?ROBOHIT )

: RESET-HITPOINTS ( -)
  RBHT @ DUP 8 >>> SWAP $FF00 AND OR RBHT !  ;

: JUST-WOUNDED? ( - f)    DIEFLAG @ 0 >  ;











: ?ROBOHIT ( -)
   KILLERFLAG @ IF
     1 DIEFLAG !
     0 RBHT !
     0 CURDEATH !  ( Kill all guards when this flag is non-zero )
     CURDEATH @ ROBODEATH
   THEN
  BLAST?
  IF ARMORED? NOT  BLASTA @ NOT OR 
    IF 
      BLASTA @  CHOSEDEATH
      DEATHATTR BITCANCELDEATH AND 0= IF  ( See if this death type is disabled. )
         CURDEATH @ ROBODEATH 
      THEN
    THEN
  THEN
  WATTRIB WEAPON@ CHOSEDEATH ( Set curdeath so we can get the right attribute )
  DEATHATTR BITCANCELDEATH AND  ( See if this death type is disabled. )
  ARMORED? WATTRIB WEAPON@ AND OR IF 
           CLEAR-BITSHOT 
           EXIT 
  THEN
  DEATH? 
  NOT  IF  
    EXIT  
  THEN
  JUST-WOUNDED?
  IF    
        AIMANGLE FASTTURNUNTIL
        
        HIT.START GA-VALUE CLT2! ( flash to hit guy frame of shooting man)
        0 RBT1 ! ( move accumulated frame time to zero)
       -1 INTFLAG BIT!
        CLX0 @  CLY0 @  ( BITREMC) 512  POISONENTRY
  ELSE
        CLX0 @  CLY0 @      800  POISONENTRY
        CURDEATH @ ROBODEATH   
        RESET-HITPOINTS
  THEN ;

( ROBOHOLSTER   fire? and holster the gun )
: ROBOHOLSTER  ( -)
    SHOOT.FLAGS GA-VALUE SHOOTFLAG_NOREVHOLSTER AND 0= IF
      SHOOT.END GA-VALUE ( just before first frame of shooting man)
      BEGIN ( frame)
       1- DUP CLT2! ( frame')
       RBQK @ 
       DEATH.DELAY GA-VALUE * 10 /
       KILL-TIME
       URF    ?ALERT    ?ROBOHIT
       ( frame) DUP SHOOT.START GA-VALUE  =  INTFLAG BIT@  OR
      UNTIL ( frame) DROP
    THEN
    WALK.START GA-VALUE CLT2!
 ;






: POTSHOT ( -)
  ( see if we hit the player, and bounce him back if we did)
   RBDIST RANGETABLE@ < IF
    RBDIST MAX_MEET_DIST < IF ( Only do CDMEET behavior if reasonably close )
       CDMEET CALL_BEHAVIOR  ( See if we have any special behavior to investigate )
    ELSE
       0 BEENCLOSEFLAG BIT!  ( Reset the BEENCLOSE flag so we can approach again  )
    THEN
      ( play the sound of a guard's gun )
(      32767 RBDIST 10 / 520 MAX /   )
      RBDIST PUSH
        R@ C_5000 2/ < IF
          63  ( Max volume if less than half the range )
        ELSE
          R@ C_5000 < IF
            C_5000 R@ - 15 * C_5000 2/ / 48 +
          ELSE
            C_5000 2* R@ - 48 * C_5000 / 0 MAX
          THEN
        THEN
      POP DROP
      
      SHOOTSND.SND GA-VALUE DUP IF
      PLAYSOUND() ELSE 2DROP THEN  16 NSHOTS +!
      ( tell there was shooting in global variable)
      RBGN @  255 AND  17 RANDR  17 RANDR *  32 +
      TF @ 2000 P*/  RBRANGE P*/ 0 > ROBOCLEARSHOT? AND
      IF
        RBGN @ 256/ 128 1024 RANDRANGE RBRANGE 400 + P*/
        DUP NHITS +!  ( record the shot on my health)
        25 * DUP  WX @  CLX0 @  -  RBRANGE P*/  BUMPX +!
        WY @ CLY0 @  -  RBRANGE P*/  BUMPY +!
        CDHIT CALL_BEHAVIOR
      THEN
   THEN  ;
   

: (ROBOSHOOT
 NOATKFLAG BIT@ IF PAUSE EXIT THEN ( Do not attack if we aren't attackers )
 $66666 ( Leave on stack for overflow test )
 AIMANGLE TURNUNTIL
 SHOOT.START GA-VALUE  CLT2!  ( first frame of shooting man )
 
 BEGIN  RBT1 @ AVGTIME @ 
   10 * SHOOT.DELAY GA-VALUE / 1 MAX
   + DUP RBT1 ! RBQK @ > DUP RBTMP8 ! ( Save for Later )
   IF  
     0 RBT1 !
   THEN
         URF
 
            ?ALERT
 
               ?ROBOHIT
         
   CLT2 @  SHOOT.BANG GA-VALUE =
   IF  
   $111114
     RBTMP8 @ IF  ( Only do potshot stuff on first transition to shoot.bang frame. )
       POTSHOT  
     THEN
   $111114 = 0= IF $1114 PYGMYERROR ! THEN ( Leave on stack for overflow test )
     SHOOT.LIGHT GA-VALUE CLT3 !  PAUSE 0 CLT3 ! ELSE  PAUSE THEN
   (  ELSE PAUSE THEN )         ( ^^^^ )
   RBTMP8 @ IF
      CLT2 @ SHOOT.START GA-VALUE MAX SHOOT.END GA-VALUE MIN 1 + CLT2! 
   THEN
   CLT2 @ SHOOT.END GA-VALUE > DUP IF 
     SHOOT.END GA-VALUE CLT2!
   THEN
   INTFLAG BIT@ OR
 UNTIL
 $66666 = 0= IF $6666 PYGMYERROR ! THEN ( Leave on stack for overflow test )
 
 $77777 
 
      ROBOCLEARSHOT? SHOOT.NSHOT GA-VALUE 1 > AND ( See if we have > 1 shot to give )
      
 SWAP $77777 = 0= IF $7777 PYGMYERROR ! THEN ( Leave on stack for overflow test )
 
 $33333 SWAP
    IF   SHOOT.LOOP GA-VALUE CLT2!  ( first frame of shooting)
      $88888
      0 ( #shots-fired)    0 RBT1 !
      BEGIN
        RBT1 @  AVGTIME @ 
        10 * SHOOT.DELAY GA-VALUE / 1 MAX
        + DUP RBT1 !  RBQK @ 3 * > DUP RBTMP8 !  ( SAVE FOR LATER )

            IF 0 RBT1 !  1+ ( #shots-fired) THEN
         URF  
 
            ?ALERT 
 
               ?ROBOHIT 
         
               CLT2 @ SHOOT.BANG GA-VALUE =
            IF 
              $121114
              RBTMP8 @ IF
                 POTSHOT  ( Only do potshot if frame newly arrived at. )
              THEN
              $121114 = 0= IF $1114 PYGMYERROR ! THEN ( Leave on stack for overflow test )
              SHOOT.LIGHT GA-VALUE CLT3 ! PAUSE 0 CLT3 ! ELSE PAUSE
            THEN 
            RBTMP8 @ IF  ( Advance frame if time has been expended. )
              CLT2 @ SHOOT.LOOP GA-VALUE MAX SHOOT.END GA-VALUE MIN 1 + CLT2!  
              CLT2 @ SHOOT.END GA-VALUE > IF
                SHOOT.LOOP GA-VALUE CLT2! ( first frame of shooting)
              THEN
            THEN
            DUP SHOOT.NSHOT GA-VALUE >  INTFLAG BIT@   OR
      UNTIL ( #shots-fired)  DROP
      $88888 = 0= IF $8888 PYGMYERROR ! THEN ( Leave on stack for overflow test )
    ELSE  ( not pointed at guy )
         SHOOT.LOOP GA-VALUE CLT2!  ( first frame of shooting)
         -1 MISSFLAG BIT!  ( didn't get a clear shot)
    THEN   
    
    ROBOHOLSTER
    
        HUNTFLAG BIT@
    IF   CHECKRANGE? IF  ROBOCLEARSHOT?
                          IF -1 INTFLAG BIT! THEN
                      THEN
    THEN 
 $33333 = 0= IF $3333 PYGMYERROR ! THEN ( Leave on stack for overflow test )
     ;                       ' (ROBOSHOOT IS ROBOSHOOT


( RBDISTLEFT)
: RBDISTLEFT  ( - u)
   RBX @  CLX0 @ - ABS
   RBY @  CLY0 @ - ABS MAX ;
COMMENT(
   Previous 2 blocks for (ROBOSHOOT are complicated.
 Do we really need to check ?ALERT and call ?ROBOHIT _during_
 the RBT1 delay?  Consider changing it to use KILL-TIME where
 nothing happens during the actual time killing.  I have hopes
 this will reduce the robot overhead without adversely affecting
 the results.  If the checks _must_ be made during the time
 killing, then keep the delay values on the stack instead of
 using RBT1.  Any chance any of the other words executed by
 (ROBOSHOOT alter RBT1 while it is being used in (ROBOSHOOT ?
)COMMENT


COMMENT(   ( removed from Feb95 version)
( SKATEUNTIL   walks until guard reaches coordinate pair x y)
: SKATEUNTIL  ( x y -)
    RBY !  RBX !    RBX @  CLX0 @  -   RBY @  CLY0 @  -
    AATAN2()  ( get angle )  ( $4000 +  )  TURNUNTIL
    BEGIN
       AVGTIME @ 8 RBSP @ P*/
       RBDISTLEFT 2DUP <
       IF 2DUP RBX @ CLX0  @ - SWAP P*/ CLX0  +!
          RBY @ CLY0  @ - SWAP P*/ CLY0  +!    0
       ELSE
          2DROP       1
       THEN  URF   ?ALERT   ?ROBOHIT    PAUSE
   UNTIL  ;
)COMMENT

: ?ROBOHOVER
   RATHOVER ATTRBTYP RATFLY ATTRBTYP OR IF
     RBTYP @ 256/ SIGN-EXTEND-BYTE DUP 200 - CLZ0 !
     RATHOVER ATTRBTYP IF
       NEGATE 12 RANDR 128 */  
       4800 RANDR 2400 - 100 / + -128 MAX 127 MIN 8 <<< 
       RBTYP @ $FF AND OR RBTYP ! 
     ELSE DROP
     THEN
   THEN
;



: RUNUNTIL   ( x y - )
    ?ROBOHOVER
    0 BLKFLAG BIT!  ( assume that walk will proceed ok)
    RBY !  RBX !       ( RBX @  CLX0 @  -  ) CLX0 @ RBX @ -   RBY @  CLY0 @  -
    AATAN2()  ( get angle )  ( $4000 + )
    ( turn the guy in the right direction before walking off)
    FASTTURNUNTIL  -1 RUNFLAG BIT!  ( guy is in dead run)
    BEGIN
       RBT1 @ AVGTIME @ 
       10 * RUN.DELAY GA-VALUE / 1 MAX
       + DUP RBT1 !
  (     RBQK @ > DUP RBTMP8 ! )
       RBQK @ / 3 MIN DUP RBTMP8 ! 
       RATSKATE ATTRBTYP OR
       IF
          RBT1 @  8  RBSP @ 2/  P*/ ( DUP  RBTMP6 ! )
          RBDISTLEFT 2DUP < IF
             2DUP RBX @  CLX0 @  -  SWAP P*/  PUSH
             RBY @ CLY0 @ - SWAP P*/
             POP 2DUP XYOK? NOT PUSH ( ??? cking deltas??)
             2DUP  CLX0 @ + SWAP  CLY0 @ + CLZ0 @ WALLXY? POP OR 0=
  ( continued on next block)

( RUNUNTIL   continued from previous block)  (  ]  )
             IF  
                ( If walk succeeded, try to open door if possible. )
                CLX0 @ CLY0 @ DOOROPEN.RANGE GA-VALUE 10 * QOPENDOOR()
                0= IF  ( Halt walking if waiting for door to open )
                  CLX0  +!  CLY0  +!
                  ELSE
                  2DROP
                THEN
                ?ROBOHOVER
                0
             ELSE
                 2DROP 1 BLKFLAG BIT!
                 ( flag that walk failed )   1
             THEN
          ELSE    2DROP   1
          THEN
          RBTMP8 @ IF
            CLT2 @ RBTMP8 @ + CLT2!
            CLT2 @ RUN.START GA-VALUE < IF
              RUN.START GA-VALUE CLT2!
            THEN 
            CLT2 @ RUN.END GA-VALUE > IF
              RUN.START GA-VALUE CLT2!
            THEN
          (  CLT2 @ 1+ RUN.STRT - 3 AND RUN.STRT + CLT2!  )
            0 RBT1 !
          THEN
        ELSE  0
       THEN  HUNTFLAG BIT@  PANICFLAG BIT@  NOT AND
       IF  CHECKRANGE? IF   ROBOCLEARSHOT?
                         IF -1 INTFLAG BIT! THEN   THEN
       THEN   URF  ?ALERT  ?ROBOHIT    PAUSE
       INTFLAG BIT@ IF DROP 1 ( exit if hit) THEN
    UNTIL  0 RUNFLAG BIT!  ( runflag off while turning) ;

( runs towards player in serpentine fashion )
: RUNSERP   ( - )
    RBRANGE 1000 > NOT  IF  EXIT  THEN
    BEGIN
       AIMANGLE  ( get angle to go directly towards player )
       SERPDIR BIT@ DUP NOT SERPDIR BIT!
       -8192 ( 45 degrees) SWAP IF NEGATE THEN +
       DUP GETSIN() 
(       NEGATE  Try negating the y coordinate to make running the right way work properly. )  
       SWAP GETCOS()  ( sin cos)
(       NEGATE  Try negating the x coordinate to make running the right way work properly. )  
       RBRANGE 3 / 1200 MIN DUP PUSH FRAC*  NEGATE  CLX0 @  +
       SWAP POP FRAC*  CLY0 @  +  ( x y)
       RUNUNTIL   INTFLAG BIT@
       BLKFLAG BIT@ OR
       ?DUP NOT IF ( leave if soldier alerted )
           RBRANGE 1000 <
       THEN
    UNTIL  ;

: RUNAWAY
  0 INTFLAG BIT!    0 BLKFLAG BIT!
  RBRANGE 2500 <
  IF  BEGIN
        AIMANGLE  ( get angle to go directly towards player )
        SERPDIR BIT@ DUP NOT SERPDIR BIT! IF
        8192 + ( 45 degrees) ELSE  8192 -  THEN
        DUP GETSIN() 
(       NEGATE  Try negating the y coordinate to make running the right way work properly. )  
        SWAP GETCOS()   ( sin cos)
(       NEGATE  Try negating the x coordinate to make running the right way work properly. )  
        RBRANGE 3 / 1200 MIN DUP PUSH FRAC*  CLX0 @  +
        SWAP  POP FRAC*  NEGATE  CLY0 @ + ( x y)
        RUNUNTIL  INTFLAG BIT@  BLKFLAG BIT@ OR
        ?DUP NOT IF ( leave if soldier alerted )
            RBRANGE 2500 >
        THEN
      UNTIL
  THEN   ;

: WALKUNTIL   ( x y - )
    ?ROBOHOVER
    0 BLKFLAG BIT!   ( assume that walk will proceed ok )
    RBY !  RBX !
      12211  ( Leave on stack for stack check )
    ( RBX @  CLX0 @  -  ) CLX0 @ RBX @ -   RBY @  CLY0 @  -
    AATAN2()  ( get angle )   ( $4000 + )  TURNUNTIL
    ( turn the guy in the right direction before walking off )
    BEGIN
     RBT1 @ AVGTIME @ 
     10 * WALK.DELAY GA-VALUE / 1 MAX
      + DUP RBT1 !   
(      RBQK @ > DUP RBTMP8 ! )
     RBQK @ / 3 MIN DUP RBTMP8 !  ( Number of frames to skip. )
     RATSKATE ATTRBTYP OR
     IF  RBT1 @ 8 RBSP @ P*/ ( DUP RBTMP6 ! )   RBDISTLEFT 2DUP <
         IF   2DUP RBX @  CLX0 @ - SWAP P*/ PUSH
              RBY @ CLY0  @ - SWAP P*/
              POP 2DUP XYOK? NOT PUSH ( ??? just deltas??)
              2DUP CLX0 @ +  SWAP CLY0 @ + CLZ0 @  WALLXY? POP OR 0=
              IF  
                ( If walk succeeded, try to open door if possible. )
                CLX0 @ CLY0 @ DOOROPEN.RANGE GA-VALUE 10 * QOPENDOOR()
                0= IF  ( halt walking if waiting for door to open )
                  CLX0  +!   CLY0  +!     
                  ELSE
                  2DROP
                THEN
                ?ROBOHOVER
                0  ( walk succeeded)
              ELSE
                  2DROP 1 BLKFLAG BIT!  1  ( walk failed)
              THEN

( WALKUNTIL    continued from previous block)   (  ]  )
         ELSE
              2DROP   1  ( walk failed)
         THEN  
         RBTMP8 @ IF  ( Only switch frames if it was really time to switch, not if skating )
           CLT2 @ RBTMP8 @ + CLT2!           0 RBT1 !
           CLT2 @  ( shouldn't incr be before the mod?)
           WALK.END GA-VALUE > IF
             WALK.START GA-VALUE CLT2!
           THEN
         THEN
     ELSE    0
     THEN  
     
     HUNTFLAG BIT@  IF CHECKRANGE? IF ROBOCLEARSHOT?
                                 IF -1 INTFLAG BIT! THEN
                               THEN  THEN
     NOATKFLAG BIT@ 0= IF
       ?ALERT
     ELSE
       RBDIST MAX_DIST_TRACKDOWN > IF
         ?ALERT 
       THEN
     THEN
     
       ?ROBOHIT
     RBDIST MAX_WALK_SENSE < IF
       RBDIST MAX_MEET_DIST < IF
         CDMEET CALL_BEHAVIOR
       ELSE
         0 BEENCLOSEFLAG BIT!  ( Reset the BEENCLOSE flag so we can approach again )
       THEN
       CDWALK CALL_BEHAVIOR
     THEN
        PAUSE
     INTFLAG BIT@ IF DROP 1 THEN  ( exit if hit)
    UNTIL   
     12211 = NOT IF  4433 PYGMYERROR ! THEN ( Leave on stack for stack check )
    ;  COMMENT(  ** warning! does call to XYOK? pass
absolute co-ords or just the deltas?  ** Also, I think addition
and 2DUP should occur _before_ tests so we don't have to add
deltas a 2nd time.   )COMMENT

( keeps guard sentried for this amount of step times )
: SENTRY ( # -)
  INTFLAG BIT@  IF ( #) DROP EXIT  THEN
  STAND.START GA-VALUE CLT2!
  BEGIN ( #)
    RBDIST MAX_MEET_DIST < IF ( Only do CDMEET behavior if reasonably close )
       CDMEET CALL_BEHAVIOR  ( See if we have any special behavior to investigate )
    ELSE
       0 BEENCLOSEFLAG BIT!  ( Reset the BEENCLOSE flag so we can approach again  )
    THEN
    CDSTAND CALL_BEHAVIOR
    
    ( If walk succeeded, try to open door if possible. )
    CLX0 @ CLY0 @ DOOROPEN.RANGE GA-VALUE 10 * QOPENDOOR() DROP
    
    RBQK @ KILL-TIME

    ( Advance to next standing frame. )
    CLT2 @ 1+ STAND.END GA-VALUE > IF 
      STAND.START GA-VALUE CLT2! 
    ELSE  
      CLT2 @ 1 + CLT2! 
    THEN 
    ?ROBOHOVER
    URF  
    NOATKFLAG BIT@ 0= IF
      ?ALERT   
    ELSE
      RBDIST MIN_DIST_START_FOLLOWING  > IF
        ?ALERT   
      THEN
    THEN
    ?ROBOHIT  (  PAUSE  )
    1-
    DUP  INTFLAG BIT@  OR
  ( repeat until time used up or until shot)
  UNTIL  DROP  ;

( Since KILL-TIME contains PAUSE, I'm not sure whether we     )
(  want the explicit PAUSE after ?ROBOHIT.                    )



: ?XYFREE ( absX absY Z - f)
   PUSH 2DUP XYOK? POP SWAP PUSH  WALLXY? 0=  POP  AND  ;



16 CONSTANT MAXLLL
VARIABLE NLLLS           ( current number of lllzones)
VARIABLE LLLPTR
VARIABLE LLLDATA  MAXLLL 2* ALLOT     ( *** sb 4* ?? ***)
     ( allot space for lost little lamb pointers)
     LLLDATA MAXLLL 2*  0 FILL ( clear data to zeros ) ( ditto)

( sees if robot is in lllzone pted to by current pointer)
: ?INLLLZONE
   LLLPTR @ @ @ CLX0  @ DUP ROT - LLLPTR @ @ 2+ @ ROT - OR
   LLLPTR @ @ 4 + @ CLY0 @ DUP ROT - LLLPTR @ @ 6 + @ ROT - OR
   OR 0< NOT  ( both x and y have to be in bounds)   ;





( leave ptr to lllzone data in lllptr )
: FINDMYZONE  ( - f)  ( true if lllzone found)
   LLLDATA LLLPTR !  ( start out pointing at first entry )
   NLLLS @
   IF      ( don't do loop if no llls in memory )
     BEGIN     ?INLLLZONE
        IF
            0 1  ( leave 0 for after until )
        ELSE
            2 LLLPTR +!
            LLLPTR @ LLLDATA - 2/ NLLLS @ > ?DUP
            ( leave true after until )
        THEN                    ( if nothing found )
     UNTIL   NOT
   ELSE  0  ( leave 0 if nllls was zero )
   THEN   ;


: RANDOMWALK ( number-segments -)
   ?ALERT   INTFLAG BIT@ IF  DROP  EXIT  THEN
   ( ie don't do any walking if going to be interrupted)
   FOR
     13111 ( Leave on TOS for stack checking )
      0 RANDLOOPS !  ( keep track of how many loops )
      BLKFLAG BIT@
      IF ( if last walkuntil hit a wall, undo last step)
         CLX0  @ DUP RBX @ - 2 / +
         CLY0  @ DUP RBY @ - 2 / +
         2DUP CLZ0 @ ?XYFREE IF WALKUNTIL ELSE 2DROP  THEN
      THEN
      INTFLAG BIT@
      IF FORLEAVE ( if soldier alerted)

   ( continued on next block )

( RANDOMWALK    continued from previous block)  (  ]  )
      ELSE  BEGIN  63 RANDR  31 -  63 RANDR  31 -  * ( n)
              200 OVER 0< IF DROP -200 THEN  +   CLX0  @ +
              63 RANDR  31 -  63 RANDR  31 -  * ( n)
              200 OVER 0< IF DROP -200 THEN  +   CLY0  @ +
              ( 50 % of the time, just walk randomly )
              ( otherwise try walk in just x or y directions)
              100 RANDR 50 < IF  DROP 0   ( replace y with 0)
                  100 RANDR 50 < IF SWAP ( make x zero ) THEN
              THEN   2DUP CLZ0 @ ?XYFREE DUP 0=
              IF PUSH 2DROP POP PAUSE THEN
              1 RANDLOOPS +!
            UNTIL   0 BLKFLAG BIT! ( reset hit-wall-flag)
            WALKUNTIL
         THEN
     13111 = NOT IF 3111 PYGMYERROR ! THEN ( Leave on TOS for stack checking )
   NEXT     ;

( a smarter replacement for walkuntil )
: SMARTWALK ( x y -)
  INTFLAG BIT@  IF  2DROP EXIT  THEN
  BEGIN
     2DUP   0 BLKFLAG BIT!  ( clear I'm stuck flag)
     WALKUNTIL   INTFLAG BIT@ 0=
     IF
        BLKFLAG BIT@
        IF     ( see if we got stuck against a wall)
           1 RANDOMWALK  ( try walking about at random)
           INTFLAG BIT@ ( leave flag on tos for until)
        ELSE  1
        THEN
     ELSE  1 ( if shot, exit immediately )
     THEN
   UNTIL       2DROP   ;
   
   
( x y - ) ( Makes guy walk around if the player is watching )
          ( but guy stays pretty close to x y coord )
: HANG_OUT
   2DUP RBLY ! RBLX !
   0 INTFLAG BIT!
   SMARTWALK  ( Walk to the target area ) 
   INTFLAG BIT@ 0= IF
     ROBOCLEARSHOT? IF
       1 RANDOMWALK ( Walk about a little )
     THEN
     10 SENTRY
   THEN
;

( LAMBWALK  ****  watch how we're locating pfa  **** )
: LAMBWALK      ( like cakewalk, only woolier)
   -1 LAMBFLAG BIT!  ( leave flag that guy is in lll mode)
   16000 MINDIST !  0 WINPATH !
   LLLPTR @ @ 8 + @ ?DUP
   IF ( only do it if #routes is non-zero)
      ( find path which brings us closest to destination)
     FOR
       I 6 * LLLPTR @ @ 10 + + ( address of x,y,pfa on stack)
       DUP @ RBX @ - ABS SWAP    2+ @ RBY @ - ABS +
       DUP MINDIST @ < IF MINDIST ! I WINPATH ! ELSE DROP THEN
     NEXT
     WINPATH @ 6 *        ( make a word ptr offset out of it)
     LLLPTR @ @ 14 + +  ( address should point to a lamb cfa)
     @ ?DUP IF   EXECUTE   THEN      ( run the damn word! )
   THEN   0 LAMBFLAG BIT! ( clear lambflag )    ;

( LOSTLAMB walks guard out of his current zone if he is in one)
( takes eventual desired destination on tos )
: LOSTLAMB  ( desired-x  desired-y -)
    RBY !  RBX !
    FINDMYZONE   ( see if we are in a zone )
    IF
      LAMBWALK
    ELSE
      -1 BLKFLAG BIT!  ( say we couldn't find a way out )
    THEN     ;







( TRYTOFIND way to abs coords, blkflag set if failure)
: TRYTOFIND ( x y -)  
   14433 ROT ROT ( Leave on TOS for stack error catching )
   0 BLKFLAG BIT!    2DUP WALKUNTIL
   NLLLS @ 3 +  ( number of defined areas  + 3)
   FOR  INTFLAG BIT@ NOT BLKFLAG BIT@ OR
     IF  0 BLKFLAG BIT!  2DUP LOSTLAMB  BLKFLAG BIT@
         IF  3 FOR  1 RANDOMWALK
                    ROBOCLEARSHOT? IF FORLEAVE THEN
             NEXT   -1 BLKFLAG BIT!
                    ( if random, then obviously not there)
         THEN  0 BLKFLAG BIT!    ROBOCLEARSHOT?
         IF   WX @ RBLX !   WY @ RBLY !  FORLEAVE
             -1 INTFLAG BIT!
         ELSE  2DUP WALKUNTIL
         THEN
     THEN ( intflag not  blkflag or )
   NEXT   2DROP 
   14433 = NOT IF 4433 PYGMYERROR ! THEN
   ;

( SMARTSERP   a smarter replacement for runserp)
: SMARTSERP ( -)
  BEGIN    0 BLKFLAG BIT!  ( clear I'm stuck flag)
    RUNSERP   INTFLAG BIT@ 0=
    IF  BLKFLAG BIT@
       IF  ( see if we got stuck against a wall)
           WX @ WY @ LOSTLAMB
              ( find way out of room if possible)
           BLKFLAG BIT@ IF 2 RANDOMWALK THEN
              ( if not, randomize )
           INTFLAG BIT@ ( leave flag on tos for until)
       ELSE   1
       THEN
    ELSE 1 ( if shot, exit immediately )
    THEN
   UNTIL ;

: ?RUNAWAY  ( - T/F )
  ( returns true if it is time to run for the hills)
     PANICFLAG BIT@
     CHARGEFLAG BIT@ NOT AND   ;













( TRACKDOWN   must be rewritten!)  ( used only by WALKORHUNT &
  SENTRYORHUNT, neither of which is used currently)
: TRACKDOWN
  NOCURIOUSFLAG BIT@ IF  ( If guard is not curious, then refuse to do trackdowns )
    0 INTFLAG BIT!
    0 PANICFLAG BIT!
    0 HUNTFLAG BIT!
    EXIT
  THEN
  RBX @   RBY @  ( ie destination) 2050 ( stack check )  0  ( ie #failures)
  BEGIN
     0 INTFLAG BIT!   0 BLKFLAG BIT!
     3 FOR  ( wait to get a clear shot)
       0 MISSFLAG BIT!    0 INTFLAG BIT!
       ROBOSHOOT  
(       RBRANGE 1024 >  )
       CHECKRANGE? 0=
       ?RUNAWAY  OR
       ROBOCLEARSHOT? 0= OR
       IF  FORLEAVE  ( only shoot once if too far)
                     ( if robo stuck, manuever a little )
       ELSE
           MISSFLAG BIT@ IF 2 RANDOMWALK THEN
       THEN
     NEXT
 ( continued on next block)

( TRACKDOWN   continued from previous block)  (   ]  )
     ?ALERT   INTFLAG BIT@ NOT
     IF  ( only run closer if we are healthy enough to do it)
         ?RUNAWAY NOT
         IF  
(             RBRANGE 1000 >   )
             ROBOCLEARSHOT? AND
             CHECKRANGE? 0=
             IF  RUNSERP  ( 4 CLT2! ) ( start him up again) THEN
             ROBOCLEARSHOT?
             IF  WX @ RBLX !  ( store position last seen )
                 WY @ RBLY !  RBRANGE 300 >
                 IF  
                     NOATKFLAG BIT@ IF
                       -1 NOCURIOUSFLAG BIT!  ( Don't let us get interrupted )
                     THEN
                     CLX0  @ WX @ + 2 /   ( walk halfway )
                     CLY0  @ WY @ + 2 / WALKUNTIL
                     NOATKFLAG BIT@ IF
                        0 NOCURIOUSFLAG BIT!  ( It's OK to be curious again. )
                     THEN
                     ( try advancing)
                 THEN
             ELSE
 ( continued on next block)


( TRACKDOWN    continued from previous block)   (   ]  )
                     NOATKFLAG BIT@ IF
                       -1 NOCURIOUSFLAG BIT!  ( Don't let us get interrupted )
                     THEN
                 RBLX @ RBLY @ TRYTOFIND  
                     NOATKFLAG BIT@ IF
                        0 NOCURIOUSFLAG BIT!  ( It's OK to be curious again. )
                     THEN
                 INTFLAG BIT@ NOT
                 IF  ROBOCLEARSHOT? NOT
                    IF  NLLLS @ 2 *
                       FOR
                         WX @ WY @ LOSTLAMB  BLKFLAG BIT@
                         INTFLAG BIT@ OR ROBOCLEARSHOT? OR
                         IF FORLEAVE THEN
                       NEXT
                    ELSE
                       WX @ RBLX !  ( store position last seen)
                       WY @ RBLY !
                    THEN
                    BLKFLAG BIT@ IF  1+  THEN ( #failures)
                 THEN
 ( continued on next block)

( TRACKDOWN   continued from previous block)   (   ]  )
             THEN
         THEN
     THEN ( intflag from ?alert set )
     0 INTFLAG BIT!   ?RUNAWAY
     IF RUNAWAY  ( try to run away )
        RBRANGE 2400 >
        IF 0 HUNTFLAG BIT!
           ( don't interrupt with more attacks)
           1   ( just leave if successfully ran away)
        ELSE
           INTFLAG BIT@
           IF  ( if we've been shot keep running away)
               0    ( keep running if shot )
           ELSE
  ( continued on next block)

( TRACKDOWN   continued from previous block)   (   ]  )
              -1 HUNTFLAG BIT!
              ( make sure we end up in attack mode again)
              -1 CHARGEFLAG BIT!
              ( turn to the attack again if shot)  0
           THEN
        THEN
     ELSE      0
     THEN    
     ( #failed  x) OVER 5 > IF DROP 1 THEN
     NOATKFLAG BIT@ IF  ( If we are just tracking the player without attacking, exit when we get close )
       RBDIST MAX_DIST_TRACKDOWN < IF
         0 INTFLAG BIT! ( Clear fact that we request to be found. )
         DROP 1
       THEN
     THEN
  UNTIL DROP
  2050 = NOT IF 2050 PYGMYERROR ! EXIT THEN
  ( now try to return guard to his original pos left on stack)
  ( TRYTOFIND    )
  2DROP
  ;





( walkorhunt does not seem to be called anywhere )
( make soldier walk smart partrol, hunt down player if alerted)
: WALKORHUNT ( x y - )
  LAMBFLAG BIT@ IF SMARTWALK
  ELSE
    0 BLKFLAG BIT!  ( verify that wall-error flag is off)
    HUNTFLAG BIT@ CLST @ ( 16) BITREMC AND 0= AND
    IF  0 INTFLAG BIT!   TRACKDOWN
        0 HUNTFLAG BIT!  0 CHARGEFLAG BIT!
    THEN   SMARTWALK
           INTFLAG BIT@ CLST  @ ( 16) BITREMC AND 0= AND
           IF   0 INTFLAG BIT!   -1 HUNTFLAG BIT!
                TRACKDOWN
                0 HUNTFLAG BIT!  0 CHARGEFLAG BIT!
           THEN
  THEN    ;

( sentryorhunt is called by 'standthere', which isn't used)
( make soldier stand sentried, hunt down player if alerted)
: SENTRYORHUNT ( time - )
    0 BLKFLAG BIT!  ( verify that wall-error flag is off)
    HUNTFLAG BIT@
    IF  DROP   TRACKDOWN
        0 HUNTFLAG BIT!  0 CHARGEFLAG BIT!
    ELSE       ( if alerted and then forgot, return to duties )
       SENTRY  INTFLAG BIT@
       IF   0 INTFLAG BIT!   -1 HUNTFLAG BIT!
            TRACKDOWN
            0 HUNTFLAG BIT!   0 CHARGEFLAG BIT!
       THEN
    THEN      ;



( debugging display)
: .DBGINIT  CLS  ;

: .DBG ( -)   CUR@  OVER 22 > IF 2DROP 7 0 THEN
  0 0 AT  ."      PF1 = "  PF1 ?
  1 0 AT  ."    PFMAX = "  PFMAX ?
  2 0 AT  ." RAWPFMAX = "  RAWPFMAX ?
  3 0 AT  ."   PFDIFF = "  PFDIFF ?
  4 0 AT  ."  INTFLAG = "  INTFLAG BIT@ .
  5 0 AT  ."   DEBUG1 = "  DEBUG1 @ U.
  6 0 AT  ."   DEBUG2 = "  DEBUG2 @ U.
  7 0 AT  ."   DEBUG3 = "  DEBUG3 @ U.
 AT   ;
: NEAR ( -)
  CLX0 @ 250 - WX !  CLY0 @  WY ! 0 WTH !  0 CLTH !  ;
 ( reposition player near robot )

( make soldier stand sentried, hunt down player if alerted)
( fcs 24May98 -- see pygmyini.4th.  Perhaps this version  )
(  needs to be modified to add ?checkrange and urf  ??    )
: STANDANDSHOOT ( time -)
  0 BLKFLAG BIT! ( verify wall-error flag is off)
  0 INTFLAG BIT!
  HUNTFLAG BIT@ NOT  IF   DUP SENTRY    THEN  DROP  (   )
  ?ALERT  INTFLAG BIT@
  IF  0 INTFLAG BIT!
     -1 HUNTFLAG BIT!          ROBOSHOOT
      INTFLAG BIT@             HUNTFLAG BIT!  ( ????)
      0 HUNTFLAG BIT!  ( ????)   0 CHARGEFLAG BIT!
  THEN  ( if alerted and then forget, return to duties)
 ;
COMMENT(  ( *** make spotting the player more OBVIOUS ***)
: STANDANDSHOOT ( time -) DROP ROBOCLEARSHOT? IF ( 1 ANYBODY +!)
  -200 14 ELSE 0 0 THEN CLT2!  CLZ0 !  ;      )COMMENT



: STANDTHERE ( -)  BEGIN  10 SENTRYORHUNT  AGAIN  ;
  ( above apparently not called)

: SET-PTIMER ( newvalue timer# -)
  2*  GLOBEFFECTS 20 +  +  W!  ( or just ! ???)  ;

: GET-PTIMER ( timer# - value)
  2*  GLOBEFFECTS 20 + + W@  ( or just @ ???)  ;








: INIT-CPTRS (  )  ( setup vectors for calling C functions)
    AATAN2        UNREL  AATAN2PTR    !
    PATH_IS_CLEAR UNREL  LOSPTR       !
    ( 'RANDN         UNREL  RANDNPTR     ! )
    GETSIN        UNREL  GETSINPTR    !
    PLAYSOUND     UNREL  PLYSNDPTR    !
    ONE_FRAME     UNREL  ONE_FRAMEPTR !
    MYLOS         UNREL  MYLOSPTR     !
    QXY           UNREL  QXYPTR       !
    QBLAST        UNREL  QXYBLASTPTR  !
    ( NEWPOINTS     UNREL  NEWPOINTPTR  ! )
     ADSQRT        UNREL  ADSQRTPTR    ! 
     SENDCHEAT     UNREL  SENDCHEATPTR !
    GETHANDLE     UNREL  GETHANDLEPTR !
    'INV_UTIL    UNREL   INV_UTILPTR ! 
    QOPENDOOR     UNREL   QOPENDOORPTR !
 ;




( build an array to hold the address of each robot task, and
  also to hold the initial word to be executed for each task)
( #SP=256, #RP=256, #USER=120?)

: TASKS: ( # -) ( - a)  FOR  TASK:  NEXT  ;

: WAKES  ( ...tasks... # -)    FOR WAKE NEXT  ;

DEFER TASKS
DEFER INITS
DEFER LOAD-PARMS


( [TASK OFFSET] [GA_OFFSET] -- [VALUE] )
: GA-LOCAL-VALUE
  SWAP RBTYP LOCAL @ MAXGT AND #GA * + GA-DATA + C@
;




( INIT-A-ROBO  this is the real one)
: INIT-A-ROBO  ( -)
  ROBONUM @ 4 * TASKS + @ PUSH (  )
  ROBONUM @ 4 * INITS + @  R@ TASK! (  )
  ROBONUM @ 1+ R@ WHOAMI LOCAL ! ( save this robot's number)
     PYGMYARG1 @ REL R@ OBP LOCAL !
     PYGMYARG1 @ 14 4 * + REL @  ( Get clt3 from guard's corresponding 3D object on stack )
      255 AND R@ BEHAVE_CODE LOCAL ! ( Set behavior code from clt3 )
     0 PYGMYARG1 @ 14 4 * + REL !  ( Set clt3 to 0 )
     GTYPENUM @ R@ RBTYP LOCAL !  ( Save guard's type number as determined by INITUNIV )
     ( Now that RBTYP has been set, we can use GA-LOCAL-VALUE to get other parameters )
     R@ MOVE.STRIDE GA-LOCAL-VALUE 20 * R@ RBSP LOCAL !  ( Set guard stride length )
     
     R@ MOVE.RANGE GA-LOCAL-VALUE 0 MAX 7 MIN 8 <<<
      R@ RBQL LOCAL @ $FF AND OR R@ RBQL LOCAL !
       
     
     R@ RBHT LOCAL @ 256/
     R@ RBHT LOCAL C!  ( init hit pts to max val )
            ( later change above to 2 separate variables)
     0 R@ BXS LOCAL !  ( init all flags to zero )
     1 GUYSLEFT +!    POP WAKE  (  )   ;

( *** fcs 2 June 98 ***                                         )
( If a Forth image is saved and later restored at a different   )
(  address, the mapping of the robot task to its associated     )
(  cl0obj object -- stored in OBP -- will no longer be correct. )
(  So, pygmyreinit in pygmy.c must correct this mapping.  The   )
(  following word will be called for each robot.                )

: RE-INIT-A-ROBO ( absolute-address-of-robot-cl0obj  robot# -)
  CELLS TASKS + @ ( addr task)
  PUSH ( addr) REL POP OBP LOCAL !  ;


COMMENT(
  This is only done once per robot at time of reading in the
  univ?.txt file.  It expects the tasks to be set up already
  in the TASKS and INITS arrays.     )COMMENT


COMMENT(
  These words, along with BECOME, are useful when debugging
  from a dual-monitor system.
)COMMENT

: NEWPAUSE ( -)  ROBOMAINTAIN  .VGA   ;
: XX   ['] NEWPAUSE IS PAUSE   ;










( Now come the specific values for the 32 tasks of PMIN)
: ADD-PARMS       DEBUG1 OFF   DEBUG2 OFF   DEBUG3 OFF
  ( rbqkM rbt1 rbsp rbht
    rbgnM rbgnL rbql rbalM rbalL task -)
  PUSH   SWAP 256 * + R@ RBAL LOCAL !
   DUP                R@ RBQL LOCAL !
             255 AND NB/QUAL * QUALTABLE +  R@ CURQUAL LOCAL !
         SWAP 256 * + R@ RBGN LOCAL !
          DUP 256 * + R@ RBHT LOCAL !
                      R@ RBSP LOCAL !
                      R@ RBT1 LOCAL !
              256 *   R@ RBQK LOCAL !
  POP DROP   ;

: AP ( same) ADD-PARMS  ;


: PYGMYINIT  ( -)
  PYGMYCOMMAND @ 3 =  ( most frequently executed )
  IF   STRTROBOTS ( run robots then 'bye')  BYE    THEN
  PYGMYCOMMAND @ 2 =  ( called by inituniv in pobj.c)
  IF  INIT-A-ROBO  ( initialize a new robot object)  BYE THEN
  PYGMYCOMMAND @ 1 =
  IF ( reset-robots ) $449 REL C@ 3 =
     IF  ." TYPE CRETURN TO RETURN TO GAME" CR   QUIT
     ELSE   1000 RETCODE !    BYE                  THEN
  THEN
  PYGMYCOMMAND @ 4 =
  IF ( init now handled by passing strings to Forth)      THEN
  PYGMYCOMMAND @ 5 =
  IF ( file loading handled by passing strings to Forth)  THEN
  BYE ( default action)   ;


: (BOOT2    0 WHOAMI ! ( for control task)
  (  $B8000 ORIGIN - DUP VIDEO-RAM !  CURSOR ! )
  ( INIT-VIDEO                                 )
  ( $B0000 VBASE !  $03B4 CRTC !  ( point to monochrome screen)
  ( CAPS ON ) CAPS OFF
  6 @ ?DUP ( get argument passed from C-program)
  IF ( a) ORIGIN - 1024 MLOAD THEN  ( BYE) QUIT   ;

 ' (BOOT2 IS BOOT
COMMENT(
 ** above is same as regular (BOOT except for ending in BYE
 instead of in QUIT  & no files are opened.  If the argument
 passed from C is non-zero, it is taken as the address of a
 string to be interpreted **  )COMMENT

(  *** Last Screen to be LOADed for now ***  )

CAPS ON  ( so lowercase source in the .4th files can load ok)
3 EXITCHAR !   ( so Ctrl-C can escape from the editor )

COMMENT(

( Some trig-testing stuff)
: 2SWAP ( a b c d - c d a b) PUSH ROT ROT POP ROT ROT ;
: 2OVER ( a b c d - a b c d a b) PUSH PUSH 2DUP POP POP 2SWAP ;
: /SCALE ( n - n/65536)  16 S>>>  ;
: SCALE* ( a b - a*b/65536)  65536 */  ;
: DEG ( degrees - 65536ths) 65536 360 */  ;
: TRANS ( x y dX dY - x' y')  ROT + PUSH + POP  ;
: ROTATE ( x y angle - x' y')
  DUP GETSIN() PUSH GETCOS() PUSH  ( x y  ||  cos sin)
  2DUP R@ SCALE* SWAP POP SCALE*  ( x y y*cos x*cos || sin)
  2SWAP ( y*cos x*cos x y || sin)
  R@ SCALE* SWAP POP SCALE* ( y*cos x*cos y*sin x*sin ||)
  PUSH - ( y*cos  x' || x*sin)  SWAP POP + ( x' y' ||)  ;






40 CONSTANT LPAREN
41 CONSTANT RPAREN
44 CONSTANT COMMA
: .C ( x y -)   ( print co-ordinates pretty)
  LPAREN EMIT
  SWAP  0 .R  COMMA  EMIT  SPACE  0 .R
  RPAREN EMIT  SPACE  ;








( Some trig-testing stuff)
: PLAYER ( - x y) WX @  WY @  ;
: 2NEG ( x y - -x -y)  NEGATE SWAP NEGATE SWAP  ;
: ROBOT ( - x y) CLX0 @  CLY0 @  ;
: dX ( - n)  CLX0 @ WX @ -  ;
: dY ( - n)  CLY0 @ WY @ -  ;

( When going from Watcom/DOS-extender to Windows, the    )
(  end of the list changed from a -1 to a NULL           )
: LASTOBJ? ( - f) CLNEXT @ ( -1  = )  0=  ;  ( end of objects?)

: NXTOBJ ( -)   CLNEXT @ REL OBP !  ;
: 1STOBJ ( -) OBJHEAD @ REL  OBP !  NXTOBJ  ;
: PREL ( - x' y')  ( ie convert to player-relative co-ords)
  ROBOT PLAYER 2NEG TRANS WTH @ ROTATE  ;


( When going from Watcom/DOS-extender to Windows, the    )
(  end of the list changed from a -1 to a NULL           )
: ANY? ( - f) OBJHEAD @ ( -1  - )  ;  ( true if obj list not empty)




( dump an object)
: .TITLES
 ."   status        x        y       rx       ry    th      rth     dist "    ;
: .DETAILS  NCLDIST CLRTH CLTH CLRY0 CLRX0 CLY0 CLX0 CLST  SPACE
  8 FOR  @  7 .R 2 SPACES  NEXT  ;
: .OBJ ( -)  CR .TITLES CR .DETAILS  ;











( traverse the list of objects and perform some action)
: TRAVERSE ( action -)
 ANY? IF  1STOBJ   BEGIN ( action)  DUP EXECUTE   ?SCROLL
                     LASTOBJ? NOT WHILE NXTOBJ
                   REPEAT ( action)   1STOBJ
    THEN  DROP  ;
VARIABLE #OBJS
: (COUNT'EM ( -)  COMMA EMIT  1 #OBJS +!  ;
: COUNT'EM  ( -)
  0 #OBJS !  ['] (COUNT'EM  TRAVERSE  SPACE  #OBJS ?  ;
: .DIST ( -) CR  NCLDIST ?  ;

)COMMENT




COMMENT(
 ******************************************************
 This is a good place to separate the PYGMYINI.4TH code
 from the GUARD??.4TH code
 ******************************************************
 )COMMENT


( 1st 32 tasks)
 32 TASKS:  T0  T1  T2  T3  T4  T5  T6  T7  T8  T9
           T10 T11 T12 T13 T14 T15 T16 T17 T18 T19
           T20 T21 T22 T23 T24 T25 T26 T27 T28 T29
           T30 T31



(  This is the real task)

: ALERTSENTRY ( -)
  ( The only task in the PMIN demo.                     )
  ( If a robot's difficulty level in clt3 can change    )
  ( dynamically we might need to put first line in      )
  ( ROBOMAINTAIN instead.                               )

  3 CLT3 @  256/ - DIFFICULTY @ < IF -1 GUYSLEFT +!  STOP  THEN
  BEGIN   10 STANDANDSHOOT   PAUSE    AGAIN  ;







 ( routines to test the new qwallxy)
COMMENT(
VARIABLE TIME#  2000 TIME# !  ( how much time to kill)
: YSIMPLEMOVE ( direction - direction') ( to test out WALLXY?)
 ( move robot in y direction, reversing when a wall is reached)
  PUSH  CLX0 @ CLY0 @ R@ 20 WHOAMI @ + *  + ( x' y')
  2DUP  CLZ0 @ WALLXY?
  IF ( ie we would hit a wall) 2DROP POP NEGATE EXIT  THEN
  ( x' y') CLY0 !  CLX0 !  POP  ( direction') ;

: ALERTSENTRY ( -)  ( the only task in the PMIN demo)
  3 CLT3 @  256/ - DIFFICULTY @ < IF -1 GUYSLEFT +!  STOP  THEN
 1 BEGIN  TIME# @ KILL-TIME   YSIMPLEMOVE   AGAIN  DROP ;
)COMMENT


COMMENT(
  ( *** fcs 2Jun98  simplify the robot tasks ***)
  ( *** for testing only, redefine ALERTSENTRY *)
  : ALERTSENTRY
    3 CLT3 @  256/ - DIFFICULTY @ < IF -1 GUYSLEFT +!  STOP  THEN
    BEGIN
       1 CLY0 +!   1 CLX0 +!
       200 KILL-TIME
       ( 200 BEGIN PAUSE AVGTIME @ - DUP 0< UNTIL DROP )
    AGAIN  ;
)COMMENT


: INIT-PMIN-DEMO-TASKS ( -)
  ['] ALERTSENTRY  MAXGUARDS FOR  DUP ,  NEXT DROP  ;














( comma in the 1st 32 tasks into a table )
CREATE (TASKS  T0 , T1 , T2 , T3 , T4 , T5 , T6 , T7 , T8 , T9 ,
  T10 , T11 , T12 , T13 , T14 , T15 , T16 , T17 , T18 , T19 ,
  T20 , T21 , T22 , T23 , T24 , T25 , T26 , T27 , T28 , T29 ,
  T30 , T31 ,

' (TASKS IS TASKS



CREATE (INITS     INIT-PMIN-DEMO-TASKS

' (INITS IS INITS












COMMENT(

  Save this way, for reference, as it also worked.

CREATE TASKS  T0 , T1 , T2 , T3 , T4 , T5 , T6 , T7 , T8 , T9 ,
  T10 , T11 , T12 , T13 , T14 , T15 , T16 , T17 , T18 , T19 ,
  T20 , T21 , T22 , T23 , T24 , T25 , T26 , T27 , T28 , T29 ,
  T30 , T31 ,
CREATE INITS ' SPINNER1 , ' SPINNER2 ,  ' SPINNER1 ,
 ' SPINNER2 , 28 INIT-TASKS ( rest execute dummy task)

)COMMENT





( Now come the specific values for the 32 tasks of PMIN)
: (LOAD-PARMS ( -)
( rbqkM rbt1 rbsp rbht rbgnM rbgnL rbql rbalM rbalL task)
      3    0  420    4    64   16     0    50     0   T0   AP
      3    0  420    4    20   16     2    50     0   T1   AP
      3    0  420    2    50   16     2    50     0   T2   AP
      3    0  420    3    30   16     2    20     0   T3   AP
      3    0  420    3    30   16     2    20     0   T4   AP
      3    0  420    3    30   16     2    20     0   T5   AP
      3    0  420    3    30   16     1    20     0   T6   AP
      3    0  420    4    20   16     1    40     0   T7   AP
      3    0  420    4    64   16     0    50     0   T8   AP
      3    0  420    4    20   16     2    50     0   T9   AP
      3    0  420    2    50   16     2    50     0   T10  AP
      3    0  420    3    30   16     2    20     0   T11  AP


( Now come more ...)       (   ]  )
( rbqkM rbt1 rbsp rbht rbgnM rbgnL rbql rbalM rbalL task)
      3    0  420    3    30   16     2    20     0   T12  AP
      3    0  420    3    30   16     2    20     0   T13  AP
      3    0  420    3    30   16     1    20     0   T14  AP
      3    0  420    4    20   16     1    40     0   T15  AP
      3    0  420    4    64   16     0    50     0   T16  AP
      3    0  420    4    20   16     2    50     0   T17  AP
      3    0  420    2    50   16     2    50     0   T18  AP
      3    0  420    3    30   16     2    20     0   T19  AP
      3    0  420    3    30   16     2    20     0   T20  AP
      3    0  420    3    30   16     2    20     0   T21  AP
      3    0  420    3    30   16     1    20     0   T22  AP
      3    0  420    5    80   32     2   100     0   T23  AP



( Now come the rest)       (   ]  )
( rbqkM rbt1 rbsp rbht rbgnM rbgnL rbql rbalM rbalL task)
      3    0  420    6    64   16     2   100     0   T24  AP
      3    0  420   10    80   32     2   100     0   T25  AP
      3    0  420    4    80   32     2   100     0   T26  AP
      3    0  420    5    80   32     2   100     0   T27  AP
      3    0  420    8    80   32     2   100     0   T28  AP
      3    0  420    6    80   32     2   100     0   T29  AP
      3    0  420    3    20   16     1   100     0   T30  AP
      3    0  420    4    20   32     1   100     0   T31  AP

  ( end of definition)   ;

 ' (LOAD-PARMS IS LOAD-PARMS


VARIABLE GUARD#  ( used during loading to help initialize the )
                 (  USER variables in the correct task        )
                 
                


( Return the task related to a particular guard number.  This )
(  is used to allow easy access to a particular task's local  )
(  variables.                                                 )
: TASK@  ( - task)  GUARD# @ CELLS TASKS + @  ;

( For debugging, RB@ takes a param like rbtyp and gives value for guard# )
: RB@ TASK@ SWAP LOCAL @ ;

: RB! TASK@ SWAP LOCAL ! ;


: action_word{ 502 ;
: }action_word drop 502 = not if 502 pygmyerror ! then ;  ( Drop the action word number )

: conditions[ 445 ;
: ]conditions swap 445 = not if 445 pygmyerror ! then ;

: actions[ 331 swap ;
: ]actions 331 = not if 331 pygmyerror ! then ;

variable curbehavenum
0 curbehavenum !

256 constant max_behave_words
create behavewords max_behave_words cells allot 

: no_behavior ;
' no_behavior constant 'no_behavior

: clear_beh max_behave_words for 'no_behavior behavewords i cells + ! next ;

clear_beh

: behavior_word{ here 901 ; ( Leave future tick address of next word on stack for saving address )

( Check stack and put definition in table of behavior word addresses. )
: }behavior_word   ( when we get here the stack should have [oldhere 901 1 ] on it. )
   swap 901 = not if 901 pygmyerror ! else push ( here on stack ) 
   6 + ( Skip over link and stuff )
   dup c@ $7f and ( get count in name )
   + 1 +  ( now we should be pointing at the pfa )
   behavewords pop cells + ! then ;


( Change status actions )
: MAKE_FRIENDLY
   -1 NOATKFLAG BIT!
   -1 NODEFENDFLAG BIT! ;
 
: MAKE_NEUTRAL
   -1 NOATKFLAG BIT!
    0 NODEFENDFLAG BIT! ;
    
: MAKE_ENEMY
   0 NOATKFLAG BIT!
   0 NODEFENDFLAG BIT! ;
    
: MAKE_INVULNERABLE  
   -1 INVULNFLAG BIT! 
   -1 EXPROOFLAG BIT! ;
   
: MAKE_VULNERABLE  
   0 INVULNFLAG BIT! 
   0 EXPROOFLAG BIT! ;
   
: MAKE_CURIOUS 0 NOCURIOUSFLAG BIT! ;
: MAKE_UNCURIOUS -1 NOCURIOUSFLAG BIT! ;

( Other actions )

( inv# value - )
: DROP_ITEM
   CLT4 @ PUSH
   16 <<<  ( shift value up 16 bits )
   SWAP 255 AND OR CLT4 ! ( OR in the ipick number )
   CLST @ BITROBODEAD OR CLST ! ( Mark robot as newly killed. )
   BEGIN ( Wait in loop until the main loop creates the item. )
     PAUSE 
     CLST @ BITROBODEAD AND 0=
   UNTIL
   POP CLT4 !  ( Restore any possible device that the guard will drop when he dies. )
;

( msg# - )
: DISPLAY_MESSAGE
   BEGIN
     QUEUEDMESSAGE @ DUP IF  ( Wait until queue is not busy )
       PAUSE
     THEN
     0=
   UNTIL
   QUEUEDMESSAGE !
;

( level# - )
: LEVEL_SWITCH 
    TNUMFLAG !
;


( sound# - ) ( plays a wave file, but adjusts the volume by distance from the player )
: MAKE_GUARD_SOUND
(  16383 RBDIST 10 / 260 MAX / )
  GETRBVOLUME
      SWAP PLAYSOUND() ;
      
( volume sound# - ) ( Plays a wav file at the specified volume 0-63, where 63 is loudest )
: MAKE_VOLUME_SOUND PLAYSOUND() ;

( - )  ( Metamorphs guard in to explosion )
: BLOW_UP_SELF 
   3610 ( Handle of explosion ) GETHANDLE() 
   6 ( fluid species ) 16 <<< OR CLT4 !
   CLST @  BITMETAMORPH OR  CLST !  ( metamorph into different object )
    STOP   
   BEGIN PAUSE 0 UNTIL ( Infinite loop forever )
;

( - ) ( Makes guard commit suicide )
: COMMIT_SUICIDE
   0 RBHT C!
   1 DIEFLAG !
   0 CURDEATH !
   CURDEATH @ ROBODEATH STOP 
   BEGIN PAUSE 0 UNTIL ( Infinite loop forever )
;

( ipick ivalue - )
: GIVE_TO_PLAYER
  2DUP 1 ROT ROT INV_UTIL() 
  DUP 0< IF 
   3100 + PYGMYERROR ! 
  ELSE 
   0= IF  ( If there was no space for it, just drop it on the floor )
     DROP_ITEM
   ELSE
     2DROP
   THEN
  THEN
;

( ipick ivalue - )  ( Take inventory item from player's inventory. )
: TAKE_FROM_PLAYER
   2 ROT ROT INV_UTIL() DROP
;

( nhits - )   ( cause damage to the player )
: DAMAGE_PLAYER NHITS +! ;

( - )  ( Forces a guard to attack the player )
: SUGGEST_ATTACK
   0 NOCURIOUSFLAG BIT!
   0 NOATKFLAG BIT!
   HUNTFLAG BIT@ 0= IF ( Make sure we aren't already attacking )
     $7fff RBAL !  ( Raise alertness to maximum amount )
     ROBOCLEARSHOT? IF
       -1 INTFLAG BIT!  ( Interrupt current activity )
     THEN
   THEN
;

( - )  ( raises all guards' alertness to maximum value )
: HEADS_UP 
    MAXGUARDS FOR
      I GUARD# !
      $7fff RBAL RB!      
    NEXT ;

( - )  ( Changes all neutral characters to hostile characters )    
: ANGRY_MOB
    MAXGUARDS FOR
      I GUARD# !
      BXS RB@ NODEFENDFLAG AND 0= IF ( Make sure is neutral )
        BXS RB@ NOATKFLAG NOCURIOUSFLAG OR  -1 XOR AND BXS RB!  ( Make hostile and curious )
      THEN
    NEXT ;
   
( - ) ( If guard is alert, this will cause him to cease to be alert )    
: CANCEL_ALERT  
    0 INTFLAG BIT!
;

( - ) ( Types the current player coordinates out on the screen )
: XY?
 CR ." Current player at:  "  WX ? SPACE WY ?
;
    
( Behavior# - ) ( Switches to another behavior )
: CHANGE_BEHAVIOR
   0 MAX 255 MIN BEHAVE_CODE !
;
      
VARIABLE RTEMP
( pfa - ) ( Restarts guard running new program )
: RUN_THIS
   RTEMP !  ( Must put pfa in variable, since we are going to kill the stack. )
   R0 @ RP! S0 @ SP!
   RTEMP @ EXECUTE
;


( ureg# value - )
: SETUREG SWAP UREG! ;

( ureg# Value - flag )
: UREG_IS_EQUAL SWAP UREG@ = ;
: UREG_IS_NOT_EQUAL SWAP UREG@ = NOT ;
: UREG_IS_GREATER_THAN SWAP UREG@ > ;
: UREG_IS_LESS_THAN SWAP UREG@ > ;
: UREG_IS_LESS_EQUAL SWAP UREG@ 1 - > ;
: UREG_IS_GREATER_EQUAL SWAP UREG@ 1 + < ;

( ureg# value - )  ( adds value to ureg )
: UREG_ADD SWAP DUP UREG@ ROT + SWAP UREG! ;

( Store things in guard's user registers. )
: GREG@ DUP 0< OVER 23 > OR IF 3000 PYGMYERROR ! DROP 0 THEN GREG0 + C@ ;
: GREG! DUP 0< OVER 23 > OR IF 3000 PYGMYERROR ! DROP 0 THEN GREG0 + C! ;

: GREG32@ DUP 0< OVER 7 > OR IF 3000 PYGMYERROR ! DROP 0 THEN CELLS GREG0 + @ ;
: GREG32! DUP 0< OVER 7 > OR IF 3000 PYGMYERROR ! DROP 0 THEN CELLS GREG0 + ! ;

( greg# value - )
: SETGREG SWAP GREG! ;

( greg# value - )
: SETGREG32 SWAP GREG32! ;

( greg# Value - flag )
: GREG_IS_EQUAL SWAP GREG@ = ;
: GREG_IS_NOT_EQUAL SWAP GREG@ = NOT ;

( greg# value - )  ( adds value to greg )
: GREG_ADD SWAP DUP GREG@ ROT + SWAP GREG! ;

( greg# Value - flag )
: GREG32_IS_EQUAL SWAP GREG32@ = ;
: GREG32_IS_NOT_EQUAL SWAP GREG32@ = NOT ;
: GREG32_IS_LESS_THAN SWAP GREG32@ > ;
: GREG32_IS_GREATER_THAN SWAP GREG32@ < ;
: GREG32_IS_LESS_EQUAL SWAP GREG32@ 1 - > ;
: GREG32_IS_GREATER_EQUAL SWAP GREG32@ 1 + < ;

( greg# value - )  ( adds value to greg )
: GREG32_ADD SWAP DUP GREG32@ ROT + SWAP GREG32! ;

( value - )  ( Set's guard's elevation )
: SET_ELEVATION CLZ0 ! ;

( ipick - flag )  ( Checks player's inventory to see if something is there )
: PLAYER_HAS_THIS
    0 SWAP 0 INV_UTIL()
;

( x y - ) ( Go to this xy location, and walk around a little if the player can see you )
          ( This is a never ending loop. )
: HANG_OUT_HERE
  RBLX @ RBLY @ 
  0 HUNTFLAG BIT!
  0 INTFLAG BIT!
  BEGIN
    2DUP HANG_OUT
    INTFLAG BIT@ NOCURIOUSFLAG BIT@ 0= OR IF 
      -1 HUNTFLAG BIT! TRACKDOWN  
      0 HUNTFLAG BIT!
      0 INTFLAG BIT!
      NOATKFLAG BIT@ IF
        -1 NOCURIOUSFLAG BIT!  ( sTOP BEING INTERESTED FOR A WHILE )
        50 SENTRY ( HANG OUT FOR A WHILE )
        3 RANDOMWALK 
        0 NOCURIOUSFLAG BIT!  ( THEN GET INTERESTED AGAIN. )
      THEN
    THEN 
    0 HUNTFLAG BIT!
    0 INTFLAG BIT!
  0 UNTIL
;

' HANG_OUT_HERE CONSTANT HANG_OUT_PROGRAM

( - flag )
: GUARD_IS_NEUTRAL NOATKFLAG BIT@ ;

( - flag )
: GUARD_IS_HOSTILE NOATKFLAG BIT@ 0= ;

( radius - flag )
: THIS_CLOSE  
   BEENCLOSEFLAG BIT@ IF
    DROP 0  ( If we have already been this close before, then forget the whole thing )
   ELSE
    RBDIST  > DUP IF -1 BEENCLOSEFLAG BIT! THEN 
   THEN ;
   
: CLOSER_THAN RBDIST > ;
   
: FARTHER_THAN RBDIST > ;

: RESET_THIS_CLOSE
   0 BEENCLOSEFLAG BIT! ;

( - flag )
: HUNTING_ME
   HUNTFLAG BIT@ NOATKFLAG BIT@ 0= AND ;
   
( - flag )
: WILL_ATTACK
   NOATKFLAG BIT@ 0= ;
   
( - flag )
: PLAYER_SHOT_NEUTRAL SHOT_A_FRIENDLY @ 0= NOT ;

( #seconds -  flag ) ( Based on frame rate, lets flag be true about once every few seconds on avg )
: ONCE_EVERY_FEW_SECONDS 1 MAX AVGTIME @ 40 * SWAP / %CHANCE0000 ;

( - flag )  ( True if guard can see player )
: CAN_SEE_PLAYER CLX0 @  CLY0 @  CLZ0 @ MYLOS() 0= ; 

: GUARD_INIT[ 1001 OVER CDINIT = ;
: ]GUARD_INIT 1001 = NOT IF 1001 PYGMYERROR ! THEN ;

: GUARD_MEET[ 1002 OVER CDMEET = ;  ( Advise that must have a THIS_CLOSE conditional for this to make sense )
: ]GUARD_MEET 1002 = NOT IF 1002 PYGMYERROR ! THEN ;

: GUARD_WALK[ 1003 OVER CDWALK = ;
: ]GUARD_WALK 1003 = NOT IF 1003 PYGMYERROR ! THEN ;

: GUARD_TURN[ 1004 OVER CDTURN = ;
: ]GUARD_TURN 1004 = NOT IF 1004 PYGMYERROR ! THEN ;

: GUARD_HITYOU[ 1005 OVER CDHIT = ;
: ]GUARD_HITYOU 1005 = NOT IF 1005 PYGMYERROR ! THEN ;

: GUARD_DIE[ 1006 OVER CDKILL = ;
: ]GUARD_DIE 1006 = NOT IF 1006 PYGMYERROR ! THEN ;

: GUARD_WOUND[ 1007 OVER CDWOUND = ;
: ]GUARD_WOUND 1007 = NOT IF 1007 PYGMYERROR ! THEN ;

: GUARD_ALERT[ 1008 OVER CDALERT = ;
: ]GUARD_ALERT 1008 = NOT IF 1008 PYGMYERROR ! THEN ;

: GUARD_STAND[ 1009 OVER CDSTAND = ;
: ]GUARD_STAND 1009 = NOT IF 1009 PYGMYERROR ! THEN ;

COMMENT(
1 CONSTANT CDMEET ( code for if get close to player )
2 CONSTANT CDWOUND ( code for if gets shot by player )
3 CONSTANT CDKILL  ( code for if guard is killed )
4 CONSTANT CDHIT   ( code for if the guard scores a hit on the player )
5 CONSTANT CDWALK  ( code for if the guard are walking )
6 CONSTANT CDTURN  ( code for if the guard is changing direction )
7 CONSTANT CDSEE   ( code for if the guard sees player )
8 CONSTANT CDINIT  ( code to be run at beginning to initialize guard )
)COMMENT

( CDcode - )  ( Calls behavior indicated by behave_code which was inited from cl0tmp3 during init-a-robo )
: (call_behavior)
  behave_code @ dup if
   dup 0 > over max_behave_words < and if
     cells behavewords + @ execute drop  ( the CDcode is left on the stack by the behavior word )
   else
    503 pygmyerror ! 2drop  ( If behave_code is out of bounds, generate error )
   then
  else
   2drop  ( If behave_code is zero, then forget the whole thing )
  then ;
  
' (call_behavior) IS CALL_BEHAVIOR

: waitthenhunt
   CDINIT call_behavior
   begin
    10 sentryorhunt
   0 until ;

: randompatrol
  CDINIT call_behavior
  begin
     2 randomwalk 
     intflag bit@ if 
      -1 huntflag bit! trackdown  
      0 huntflag bit!
      0 intflag bit!
      noatkflag bit@ if
        -1 nocuriousflag bit!  ( Stop being interested for a while )
        50 sentry ( hang out for a while )
        3 randomwalk 
        0 nocuriousflag bit!  ( then get interested again. )
      then
     then 
  0 until ;

: staystanding
   CDINIT call_behavior
   begin
    10 standandshoot
   0 until
;

: turnwhenshot
   begin
     shot?
     clear-bitshot
     if
       AIMANGLE turnuntil
     then
     pause
   0 until
;

' waitthenhunt constant program_nopatrol
' randompatrol constant program_randompatrol
' staystanding constant program_staystanding 
( ' turnwhenshot constant 'staystanding )

( 0 constant rbqk       ( quickness of a robot )
( 1 constant rbt1 ( temporary storage spot )
( 2 constant rbsp ( speed of a robot )
( 6 constant rbht ( mx hit pts *256 + current hit points )
( 7 constant rbgn ( gun strength* 256 + gun skill )
( 8 constant rbql ( unused * 256 + quality of guard in general )
( 9 constant rbal  ( current alertness of guard * 256 with fractional part )



( Make a list of possible guard orders.  Initialize the whole thing with randompatrol. )
( If a user wants to make a script, he can write it into guardsrc.4th and add it to the )
( orders array. )
256 CONSTANT MAXNUMORDERS

CREATE ORDERSARRAY MAXNUMORDERS CELLS ALLOT

: CLEAR_ORDERS_ARRAY MAXNUMORDERS FOR 'randompatrol ORDERSARRAY I CELLS + ! NEXT ;

CLEAR_ORDERS_ARRAY

program_nopatrol ORDERSARRAY 0 CELLS + !
program_randompatrol ORDERSARRAY 1 CELLS + !
program_staystanding ORDERSARRAY 2 CELLS + !



( [orders#] -- []  Sets a guards orders to 0=sentry then hunt )
(                                          1=random patrol then hunt )
(                                          2=stand and shoot w/o walking )
: getorders ( # -)
     dup 0< if drop 0 then
     dup MAXNUMORDERS 1 - > if drop 0 then
     ORDERSARRAY swap CELLS + @  ( Get orders from orders array )
     ( xt) GUARD# @ CELLS INITS +  !  ( assign executable to task)
  ;

( [quickness value] -- []  set this guard's quickness to value 1 thru 6 )
: setspeed ( # -)  1 max 6 min 256 *  TASK@ RBQK LOCAL !  ;

( [hitpts] -- []      Set this guard's hitpts to value 1 through 63 )
: sethitpts ( # -)  1 max 63 min 256 *  TASK@ RBHT LOCAL !  ;

( [gun skill]  [gun strength] -- []  Set guard's gun power and accuracy )
(                                   !!!!!!!!! note this word takes *2* values! )
: setgun ( skill strength -)
  1 max 31 min 256 * +   TASK@ RBGN LOCAL !  ;

( [alertness value] -- []    Set this guard's initial alertness value 10-127 )
: setalert ( # -)
  10 max 127 min 256 * ( n)  TASK@ RBAL LOCAL !  ;

( [quality] -- []  Set the guard's quality to value from 0 thru 3 )
(                  !!!!!! strange:  0=dumb  1=avg  2=great 3=vegetable )

: SETQUAL  ( # -)
  DUP 
  TASK@ PUSH ( #)
  0 MAX 3 MIN  R@ RBQL LOCAL @ $FF00 AND OR  POP RBQL LOCAL ! 
  255 AND NB/QUAL * QUALTABLE +  TASK@ CURQUAL LOCAL ! ;

( [rangecode] -- []  Set the guard's attack range to value from 0 thru 7 )
( 0=max range,  7 = only when touching player )
: SETRANGE ( # -)
  TASK@ PUSH ( #)
  0 MAX 7 MIN 8 <<<   R@ RBQL LOCAL @  $FF AND OR
  POP RBQL LOCAL !  ;

: setdefaults  ( -)  TASK@ ( task) PUSH
   ( fcs -- Under the new approach, the word that the task  )
   (  will execute is stored in the array of CELLS named    )
   (  INITS )

   ( 'nopatrol rstrt robo[]! )
   program_nopatrol  GUARD# @ CELLS INITS +  !  ( assign executable to task)
        GTYPENUM @  R@ RBTYP LOCAL ! ( 256* zoff+ gtype number, init-a-robo will overwrite )
         3 256 *  R@ RBQK  LOCAL ! ( quickness)
               0  R@ RBT1  LOCAL !
            820  R@ RBSP  LOCAL ! ( speed, put in default, but init-a-robo will overwrite )
         4 256 *  R@ RBHT  LOCAL !
   64 256 * 16 +  R@ RBGN  LOCAL !
               0  setqual
    50 256 * 0 +  R@ RBAL  LOCAL !
   POP ( task) DROP
 ;

( Make this guard# the current guard for setting params )
(  and set defaults                                     )
: SETGUARD#  ( guard# -)  GUARD# ! (  )  SETDEFAULTS  ;

: KEVIN CR ." Hi!" CR ;

CODE REL@ b push di b mov NXT, END-CODE

VARIABLE CBUF 64 ALLOT
: COLLECT_CHEATSTRING CR ." Enter code : "
  CBUF 64 0 FILL ( Clear buffer )
  CBUF 64 EXPECT 
  CBUF UNREL SENDCHEAT() ( Send the string to C to deal with )
  BYE ;



( CLOSE-FILES )
 SAVE FTHM4.IMG 
( SAVE \PMIN\FTHM4.IMG )
( SAVE E:\GCS\ENGINE\FTHM4.IMG )


CR  ." AFTER  HERE = " HERE U.  CR


( CR ." YOU HAVE REACHED THE END OF THE FILE! "  CR )


EXIT
 

